// AppObjectCtl.h : Declaration of the CAppObject

#ifndef __APPOBJECT_H_
#define __APPOBJECT_H_

#include "resource.h"       // main symbols
#include "AppObjectCP.h"
#include <afxres.h> // ID_FILE_SAVE/PRINT, etc...

/////////////////////////////////////////////////////////////////////////////
// CAppObject
class ATL_NO_VTABLE CAppObject : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CAppObject, &CLSID_AppObject>,
	public ISupportErrorInfo,
	public IConnectionPointContainerImpl<CAppObject>,
	public IDispatchImpl<IAppObject, &IID_IAppObject, &LIBID_APPOBJECTLib>,
	public IObjectSafetyImpl<CAppObject, INTERFACESAFE_FOR_UNTRUSTED_CALLER|INTERFACESAFE_FOR_UNTRUSTED_DATA>,
	public CProxy_IAppObjectEvents< CAppObject >,
	public CComControl<CAppObject>,
	public IProvideClassInfo2Impl<&CLSID_AppObject, &DIID__IAppObjectEvents>
{
public:
	CAppObject() :
		m_hWnd(NULL),
		m_CMFCView(NULL,this,1)
	{
		// Note ATL initializes the caption to be empty and
		// the document interface to be NULL.
	}

	void FinalRelease()
	{
		// Unsubclass the edit control
		m_CMFCView.UnsubclassWindow();
	}

DECLARE_REGISTRY_RESOURCEID(IDR_APPOBJECT)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CAppObject)
	COM_INTERFACE_ENTRY(IAppObject)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY(IObjectSafety)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
END_COM_MAP()

BEGIN_CONNECTION_POINT_MAP(CAppObject)
	CONNECTION_POINT_ENTRY(DIID__IAppObjectEvents)
END_CONNECTION_POINT_MAP()

BEGIN_MSG_MAP(CAppObject)
	// Message map
ALT_MSG_MAP(1)
	// Alternate message map
	MESSAGE_HANDLER(WM_COMMAND, OnCommand)
END_MSG_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// IAppObject
public:
	STDMETHOD(InitHwnd)(OLE_HANDLE hWnd);
	STDMETHOD(Quit)();
	STDMETHOD(SetDocument)(/*[in]*/ LPDISPATCH newVal);
	STDMETHOD(get_Document)(/*[out, retval]*/ VARIANT *pVal);
	STDMETHOD(get_Height)(/*[out, retval]*/ VARIANT *pVal);
	STDMETHOD(put_Height)(/*[in]*/ VARIANT newVal);
	STDMETHOD(get_Width)(/*[out, retval]*/ VARIANT *pVal);
	STDMETHOD(put_Width)(/*[in]*/ VARIANT newVal);
	STDMETHOD(get_Top)(/*[out, retval]*/ VARIANT *pVal);
	STDMETHOD(put_Top)(/*[in]*/ VARIANT newVal);
	STDMETHOD(get_Left)(/*[out, retval]*/ VARIANT *pVal);
	STDMETHOD(put_Left)(/*[in]*/ VARIANT newVal);
	STDMETHOD(get_WindowState)(/*[out, retval]*/ VARIANT *pVal);
	STDMETHOD(put_WindowState)(/*[in]*/ VARIANT newVal);
	STDMETHOD(get_Caption)(/*[out, retval]*/ VARIANT *pVal);
	STDMETHOD(put_Caption)(/*[in]*/ VARIANT newVal);

// Subclassed MFC CEditView message handlers
protected:
	LRESULT OnCommand(UINT, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		// Check for our commands and fire the event
		switch ( wParam ) {
			case ID_FILE_NEW:
				Fire_DocumentNew();
				break;

			case ID_FILE_OPEN:
				Fire_DocumentOpen();
				break;

			case ID_FILE_SAVE:
				Fire_DocumentSave();
				break;

			case ID_FILE_SAVE_AS:
				Fire_DocumentSaveAs();
				break;

		} // switch
		
		// Allow the window to handle the command
		return m_CMFCView.DefWindowProc(WM_COMMAND,wParam,lParam);
	}

private:
	CComPtr<IDispatch> m_pDocument;
	HWND m_hWnd;
	CContainedWindow m_CMFCView;
};

#endif //__APPOBJECT_H_
