// DIBHolder.h : interface of the CDIBHolder class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_DIBHOLDER_H__7943CF4C_97F3_11D2_8329_C9FC06FDC82E__INCLUDED_)
#define AFX_DIBHOLDER_H__7943CF4C_97F3_11D2_8329_C9FC06FDC82E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CDIBHolder : public CObject
{
// Construction
public:
	CDIBHolder::CDIBHolder();
	CDIBHolder(const char* szFilename);
	virtual ~CDIBHolder();

// Implementation
public:
    void LoadDIBFile(const char* szFilename);
    DWORD GetSize();
    UINT Width();
    UINT Height();
    UINT GetNumColors();
	LPBITMAPINFOHEADER GetDIBInfoHeader() { return m_pbmInfoHeader; }
	LPBITMAPINFO GetDibInfo() { return m_pbmInfo; }
	LPRGBQUAD GetDIBRGBTable() { return m_pRGBTable; }
	BYTE* GetDIBBits() { return m_pDIBBits; }

// Attributes
protected:
	BYTE* m_pDIB;
	LPBITMAPFILEHEADER m_pbmFileHeader;
	LPBITMAPINFOHEADER m_pbmInfoHeader;
	LPBITMAPINFO m_pbmInfo;
	RGBQUAD* m_pRGBTable;
	BYTE* m_pDIBBits;
	UINT m_iNumColors;

};

#endif // AFX_DIBHOLDER_H__7943CF4C_97F3_11D2_8329_C9FC06FDC82E__INCLUDED_
