// DocNavigatorView.cpp : implementation of the CDocNavigatorView class
//

#include "stdafx.h"
#include "DocNavigator.h"

#include "DocNavigatorDoc.h"
#include "MainFrm.h"
#include "DocNavigatorView.h"

// DHTML definitions
#include "MSHTML.H"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDocNavigatorView

IMPLEMENT_DYNCREATE(CDocNavigatorView, CHtmlView)

BEGIN_MESSAGE_MAP(CDocNavigatorView, CHtmlView)
	//{{AFX_MSG_MAP(CDocNavigatorView)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CHtmlView::OnFilePrint)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDocNavigatorView construction/destruction

CDocNavigatorView::CDocNavigatorView() :
	m_bUpdateTree(TRUE)
{
	// TODO: add construction code here

}

CDocNavigatorView::~CDocNavigatorView()
{
}

BOOL CDocNavigatorView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CHtmlView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CDocNavigatorView drawing

void CDocNavigatorView::OnDraw(CDC* pDC)
{
	CDocNavigatorDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
}

void CDocNavigatorView::OnInitialUpdate()
{
	CHtmlView::OnInitialUpdate();

	// Load an initial HTML page from this app's
	// resources.
	LoadFromResource(IDR_DEFAULTDOC);
}

/////////////////////////////////////////////////////////////////////////////
// CDocNavigatorView printing


/////////////////////////////////////////////////////////////////////////////
// CDocNavigatorView diagnostics

#ifdef _DEBUG
void CDocNavigatorView::AssertValid() const
{
	CHtmlView::AssertValid();
}

void CDocNavigatorView::Dump(CDumpContext& dc) const
{
	CHtmlView::Dump(dc);
}

CDocNavigatorDoc* CDocNavigatorView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDocNavigatorDoc)));
	return (CDocNavigatorDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDocNavigatorView message helpers

void CDocNavigatorView::LoadURL(LPCTSTR strURL)
{
	// Update the tree control
	m_bUpdateTree = TRUE;

	// Load the document found at the URL
	Navigate2(strURL,NULL,NULL);
}

void CDocNavigatorView::NavigateAnchor(LPCTSTR strItem)
{
	// Navigate to an internal bookmark
	if ( strItem != NULL ) {
		// Retrieve the document's IDispatch pointer
		CComPtr<IDispatch> pDocDispatch = GetHtmlDocument();

		// QI for the IHTMLDocument2 pointer
		CComQIPtr<IHTMLDocument2,&IID_IHTMLDocument2> pHTMLDocument2(pDocDispatch);
		if ( !pHTMLDocument2 ) {
			AfxMessageBox(_T("IHTMLDocument2 interface not supported."));
			// This version of Internet Explorer doesn't 
			// support DHTML...
			ASSERT(FALSE);
			return;
		} // if

		// Retrieve the IHTMLLocation pointer
		CComPtr<IHTMLLocation> pHTMLLocation;
		HRESULT hr = pHTMLDocument2->get_location(&pHTMLLocation);
		if ( FAILED(hr) ) {
			AfxMessageBox(_T("Error retrieving IHTMLLocation interface."));
			// Unknown internal Internet Explorer error...
			ASSERT(FALSE);
			return;
		} // if

		// Navigate to the bookmark (known as a "hash",
		// which is the address portion of the URL
		// following the pound, '#')
		CComBSTR bstrHash(strItem);
		pHTMLLocation->put_hash(bstrHash);
		// Note no check of the return code...it either
		// navigated or it didn't...if you wanted to check
		// the HRESULT for some error condition, feel free
		// to do so.
	} // if
}

/////////////////////////////////////////////////////////////////////////////
// CDocNavigatorView message handlers

void CDocNavigatorView::OnFileOpen() 
{
	// File filter
	static TCHAR BASED_CODE szHTMLFilter[] = _T("HTM Files (*.htm)|*.htm|HTML Files (*.html)|*.html|All Files (*.*)|*.*||");	

	// Bring up a file dialog to browse for HTML files.
	CFileDialog dlgHTML(TRUE,
					_T("htm"),
					NULL,
					OFN_EXPLORER,
					szHTMLFilter,
					this);

	dlgHTML.m_ofn.lpstrTitle = _T("Open HTML file");

	if ( dlgHTML.DoModal() != IDOK ) {
		// User canceled...
		return;
	} // if

	// Pull file location
	CString strUrl(_T("file://"));
	strUrl += dlgHTML.GetPathName();

	// Update the tree control
	m_bUpdateTree = TRUE;

	// Open the file
	Navigate2(strUrl,NULL,NULL);
}

void CDocNavigatorView::OnDocumentComplete(LPCTSTR lpszURL) 
{
	CHtmlView::OnDocumentComplete(lpszURL);
	
	// This event is fired whenever the browser receives a
	// navigation request.  There isn't any reason to
	// reload the document if we're only navigating to a
	// bookmark, so we check to be sure we're actually
	// reloading a document before we go to the trouble
	// of reloading the tree control also.
	if ( m_bUpdateTree ) {
		// Update the tree control
		CMainFrame* pFrame = reinterpret_cast<CMainFrame*>(AfxGetMainWnd());
		pFrame->UpdateTree(GetHtmlDocument(),lpszURL);
		pFrame->SetURL(lpszURL);

		// Reset our gate
		m_bUpdateTree = FALSE;
	} // if
}
