// GLMinMDIView.cpp : implementation of the CGLMinMDIView class
//

#include "stdafx.h"
#include "GLMinMDI.h"

#include "GLMinMDIDoc.h"
#include "GLMinMDIView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGLMinMDIView

IMPLEMENT_DYNCREATE(CGLMinMDIView, CGLView)

BEGIN_MESSAGE_MAP(CGLMinMDIView, CGLView)
	//{{AFX_MSG_MAP(CGLMinMDIView)
	ON_WM_SIZE()
	ON_COMMAND(ID_VIEW_OPENGLPORT, OnViewOpenglport)
	ON_UPDATE_COMMAND_UI(ID_VIEW_OPENGLPORT, OnUpdateViewOpenglport)
	ON_WM_ERASEBKGND()
	ON_COMMAND(ID_VIEW_FLICKERFREE, OnViewFlickerfree)
	ON_UPDATE_COMMAND_UI(ID_VIEW_FLICKERFREE, OnUpdateViewFlickerfree)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CGLView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CGLView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CGLView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGLMinMDIView construction/destruction

CGLMinMDIView::CGLMinMDIView() :
	m_bRenderProportional(FALSE),
	m_bRenderFlickerFree(TRUE)
{
	// TODO: add construction code here

}

CGLMinMDIView::~CGLMinMDIView()
{
}

BOOL CGLMinMDIView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CGLView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CGLMinMDIView drawing

void CGLMinMDIView::OnDraw(CDC* pDC)
{
	CGLMinMDIDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// Draw the OpenGL scene
    wglMakeCurrent(pDC->m_hDC, m_hRC);
    RenderView();
	SwapBuffers(pDC->m_hDC);
    wglMakeCurrent(pDC->m_hDC, NULL);
}

/////////////////////////////////////////////////////////////////////////////
// CGLMinMDIView printing

BOOL CGLMinMDIView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CGLMinMDIView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CGLMinMDIView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CGLMinMDIView diagnostics

#ifdef _DEBUG
void CGLMinMDIView::AssertValid() const
{
	CGLView::AssertValid();
}

void CGLMinMDIView::Dump(CDumpContext& dc) const
{
	CGLView::Dump(dc);
}

CGLMinMDIDoc* CGLMinMDIView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CGLMinMDIDoc)));
	return (CGLMinMDIDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CGLMinMDIView message handlers

void CGLMinMDIView::DrawGLSquare()
{
	glBegin(GL_LINES); // square in X-Y plane
		glVertex3f(-1.0f, 1.0f, 0.0f);
		glVertex3f(-1.0f, -1.0f, 0.0f);

		glVertex3f(-1.0f, -1.0f, 0.0f);
		glVertex3f(1.0f, -1.0f, 0.0f);

		glVertex3f(1.0f, -1.0f, 0.0f);
		glVertex3f(1.0f, 1.0f, 0.0f);

		glVertex3f(1.0f, 1.0f, 0.0f);
		glVertex3f(-1.0f, 1.0f, 0.0f);
	glEnd();
}

void CGLMinMDIView::RenderView()
{
	glPushMatrix();

		glScalef(10.0f,10.0f,0.0f);
		DrawGLSquare();

	glPopMatrix();

	glPushMatrix();

		glScalef(5.0f,5.0f,0.0f);
		glRotatef(45.0f,0.0f,0.0f,1.0f);

		DrawGLSquare();

	glPopMatrix();
}

void CGLMinMDIView::OnSize(UINT nType, int cx, int cy) 
{
	CGLView::OnSize(nType, cx, cy);
	
	// Check for proportional rendering...
	if ( m_bRenderProportional ) {
		// Reset the viewport to render proportionally
		CClientDC dcClient(this);
		wglMakeCurrent(dcClient.m_hDC,m_hRC);
		glViewport(0,0,min(cx,cy),min(cx,cy));
		wglMakeCurrent(NULL,NULL);
	} // if
}

void CGLMinMDIView::OnViewOpenglport() 
{
	// Toggle status
	m_bRenderProportional = !m_bRenderProportional;

	// Force the window to resize automatically, thus
	// enabling the viewport change to take effect.
	ShowWindow(SW_MINIMIZE);
	ShowWindow(SW_RESTORE);
}

void CGLMinMDIView::OnUpdateViewOpenglport(CCmdUI* pCmdUI) 
{
	// Check/uncheck the item
	pCmdUI->SetCheck(m_bRenderProportional);
}

BOOL CGLMinMDIView::OnEraseBkgnd(CDC* pDC) 
{
	// Check to see if we're flicker free...
	if ( m_bRenderFlickerFree ) {
		// We are so say we handled it...
		return TRUE;
	} // if

	// Force the standard MFC behavior.  Note I call
	// CView for this chore, *not* CGLView, which
	// would handle this correctly.
	return CView::OnEraseBkgnd(pDC);
}

void CGLMinMDIView::OnViewFlickerfree() 
{
	// Toggle status
	m_bRenderFlickerFree = !m_bRenderFlickerFree;
}

void CGLMinMDIView::OnUpdateViewFlickerfree(CCmdUI* pCmdUI) 
{
	// Check/uncheck the item
	pCmdUI->SetCheck(m_bRenderFlickerFree);
}
