// GLObjectView.h : interface of the CGLObjectView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_GLOBJECTVIEW_H__F5C26FCF_9115_11D2_B21B_00C04FBEDB8F__INCLUDED_)
#define AFX_GLOBJECTVIEW_H__F5C26FCF_9115_11D2_B21B_00C04FBEDB8F__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

// Our base class
#include "GLView.h"

class CGLObjectView : public CGLView
{
protected: // create from serialization only
	CGLObjectView();
	DECLARE_DYNCREATE(CGLObjectView)

// Attributes
public:
	CGLObjectDoc* GetDocument();

// Operations
public:
	void Normal( GLfloat* pt1, GLfloat* pt2, GLfloat* pt3,  double* n );
	void RenderView();
	void SetupLight();
	void RenderWireCube();
	void RenderSolidCube();
	void RenderShadedCube();
	void RenderWireSphere();
	void RenderSolidSphere();
	void RenderShadedSphere();
	void RenderWireTorus();
	void RenderSolidTorus();
	void RenderShadedTorus();
	void RenderWireDodec();
	void RenderSolidDodec();
	void RenderShadedDodec();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGLObjectView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CGLObjectView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	// Rotational parameters
    GLfloat m_fXRotate;
    GLfloat m_fYRotate;
    GLfloat m_fZRotate;

	// Translational parameters
	GLfloat m_fScaleX;
	GLfloat m_fScaleY;
	GLfloat m_fScaleZ;
	GLfloat m_fZTranslate;

	// Material parameters
	GLfloat m_fMaterialAmbient[4];
	GLfloat m_fMaterialEmitted[4];
	GLfloat m_fMaterialSpecular[4];
	GLfloat m_fMaterialShininess;

	// Light parameters
	GLfloat m_fLightAmbient0[4];
	GLfloat m_fLightDiffuse0[4];
	GLfloat m_fLightSpecular0[4];
	GLfloat m_fLightPosition0[4];
	GLfloat m_fLightAmbient1[4];
	GLfloat m_fLightDiffuse1[4];
	GLfloat m_fLightSpecular1[4];
	GLfloat m_fLightPosition1[4];

	// Class state parameters
	int m_iObject;
	BOOL m_bDrawAxes;
	BOOL m_bDoSpotlight;
	int m_iRenderStyle;
	BOOL m_bMouseActive;
	CPoint m_ptActive;

	//{{AFX_MSG(CGLObjectView)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	//}}AFX_MSG
	afx_msg void OnChangeObject(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnChangeRender(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnChangeScale(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnChangeProps(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnChangeSpot(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnChangeAxes(NMHDR* pNMHDR, LRESULT* pResult);
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in GLObjectView.cpp
inline CGLObjectDoc* CGLObjectView::GetDocument()
   { return (CGLObjectDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GLOBJECTVIEW_H__F5C26FCF_9115_11D2_B21B_00C04FBEDB8F__INCLUDED_)
