// GLSceneView.h : interface of the CGLSceneView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_GLSCENEVIEW_H__BC305E71_9426_11D2_B21C_00C04FBEDB8F__INCLUDED_)
#define AFX_GLSCENEVIEW_H__BC305E71_9426_11D2_B21C_00C04FBEDB8F__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

// Our base class
#include "GLView.h"

// Our display list numbers.  Note since I'm using the
// auxiliary OpenGL functions, I didn't start my display
// list numbering at zero.  This is because the aux
// library will use 1-?, where ? is the number of different
// aux shapes you are using.  In this case, I'm using two
// (sphere and dodecahedron), so I could've started my
// count at three.  However, it's safer to give the aux
// library a wide berth in case you add additional shapes.
#define SOLIDCUBE	32
#define ALPHACUBE	33
#define AXES		34

class CGLSceneView : public CGLView
{
protected: // create from serialization only
	CGLSceneView();
	DECLARE_DYNCREATE(CGLSceneView)

// Attributes
public:
	CGLSceneDoc* GetDocument();

// Operations
public:

protected:
	void RenderView();
	void SetupLight();
	void CreateDisplayLists();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGLSceneView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL DestroyWindow();
	protected:
	virtual void OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CGLSceneView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	GLfloat m_fYRotate;
	GLfloat m_fAlpha;
	UINT m_iTimerID;
	BOOL m_bDoAlpha;
	BOOL m_bDoFog;
	BOOL m_bDoAxes;

	// Light parameters
	GLfloat m_fLightAmbient0[4];
	GLfloat m_fLightDiffuse0[4];
	GLfloat m_fLightSpecular0[4];
	GLfloat m_fLightPosition0[4];

	// Fog color
	GLfloat m_fFogColor[4];

	//{{AFX_MSG(CGLSceneView)
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnViewAxes();
	afx_msg void OnUpdateViewAxes(CCmdUI* pCmdUI);
	afx_msg void OnViewAlpha();
	afx_msg void OnUpdateViewAlpha(CCmdUI* pCmdUI);
	afx_msg void OnViewFog();
	afx_msg void OnUpdateViewFog(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in GLSceneView.cpp
inline CGLSceneDoc* CGLSceneView::GetDocument()
   { return (CGLSceneDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GLSCENEVIEW_H__BC305E71_9426_11D2_B21C_00C04FBEDB8F__INCLUDED_)
