// GLTexCubeView.h : interface of the CGLTexCubeView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_GLTEXCUBEVIEW_H__7943CFB0_97F3_11D2_8329_C9FC06FDC82E__INCLUDED_)
#define AFX_GLTEXCUBEVIEW_H__7943CFB0_97F3_11D2_8329_C9FC06FDC82E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GLView.h"
#include "DIBHolder.h"

#define TEXCUBE	32

class CGLTexCubeView : public CGLView
{
protected: // create from serialization only
	CGLTexCubeView();
	DECLARE_DYNCREATE(CGLTexCubeView)

// Attributes
public:
	CGLTexCubeDoc* GetDocument();

// Operations
public:

protected:
	void InitColorTables();
	void RenderView();
	void CreateDisplayList();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGLTexCubeView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL DestroyWindow();
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CGLTexCubeView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	UINT m_iTimerID;
	CDIBHolder m_CDIBHolder;
	GLfloat m_yRotate;
	GLfloat m_rgbRed[256];
	GLfloat m_rgbGreen[256];
	GLfloat m_rgbBlue[256];

	//{{AFX_MSG(CGLTexCubeView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in GLTexCubeView.cpp
inline CGLTexCubeDoc* CGLTexCubeView::GetDocument()
   { return (CGLTexCubeDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GLTEXCUBEVIEW_H__7943CFB0_97F3_11D2_8329_C9FC06FDC82E__INCLUDED_)
