// InetSessionDlg.cpp : implementation file
//

#include "stdafx.h"
#include "InetSession.h"
#include "InetSessionDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CInetSessionDlg dialog

CInetSessionDlg::CInetSessionDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CInetSessionDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CInetSessionDlg)
	m_sResult = _T("");
	m_sUrl = _T("");
	m_sStatus = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CInetSessionDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CInetSessionDlg)
	DDX_Text(pDX, IDC_ERESULT, m_sResult);
	DDX_Text(pDX, IDC_EURL, m_sUrl);
	DDX_Text(pDX, IDC_SSTATUS, m_sStatus);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CInetSessionDlg, CDialog)
	//{{AFX_MSG_MAP(CInetSessionDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BURL, OnBurl)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CInetSessionDlg message handlers

BOOL CInetSessionDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	// Set the Session class' pointer to this dialog window
	m_misSession.SetParentDialog(this);

	// Enable the status callback function
	m_misSession.EnableStatusCallback(TRUE);

	// Initialize the screen variables
	m_sStatus = "Waiting";
	m_sUrl = "http://www.microsoft.com/";
	m_sResult = "";
	UpdateData(FALSE);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CInetSessionDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CInetSessionDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CInetSessionDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CInetSessionDlg::UpdateStatus(CString sNewStatus)
{
	// Update the screen with the current status
	m_sStatus = sNewStatus;
	UpdateData(FALSE);
}

void CInetSessionDlg::OnBurl() 
{
	CStdioFile* fpUrlFile;
	CString sCurLine;
	// TODO: Add your control notification handler code here

	// Get the screen control variables
	UpdateData(TRUE);

	// Open the URL specified
	fpUrlFile = m_misSession.OpenURL(m_sUrl);

	// Did we received an valid Internet file pointer?
	if (fpUrlFile)
	{
		// Read lines of text from the file until all has
		// been received
		while (fpUrlFile->ReadString(sCurLine))
		{
			// Add the new line to the text control
			// and sync with the dialog screen.
			m_sResult += sCurLine;
			UpdateData(FALSE);
		}
	}
}

void CInetSessionDlg::OnCancel() 
{
	// TODO: Add extra cleanup here

	// Close the Internet Session
	m_misSession.Close();

	// Close the dialog
	CDialog::OnCancel();
}
