// LightPage.cpp : implementation file
//

#include "stdafx.h"
#include "GLObject.h"
#include "LightPage.h"

#include "MainFrm.h"
#include "GLObjectDoc.h"
#include "GLObjectView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLightPage property page

IMPLEMENT_DYNCREATE(CLightPage, CPropertyPage)

CLightPage::CLightPage() :
	CPropertyPage(CLightPage::IDD),
	m_iCurrentIndex(0)
{
	//{{AFX_DATA_INIT(CLightPage)
	m_strPropText = _T("");
	m_strMinText = _T("");
	m_strPositionText = _T("");
	m_strMaxText = _T("");
	m_bDoSpotlight = FALSE;
	//}}AFX_DATA_INIT

	// We need to fill our tree node data structures for 
	// easy access to the particular property information
	// we're interested in.  This is all in an array to
	// alleviate memory issues (leaks), since we have a
	// static number of properties.
	m_tdNodeData[0].strPropText = _T("Ambient light, red");
	m_tdNodeData[0].iProperty = LIGHT_AMBIENT;
	m_tdNodeData[0].iComponent = RED;
	m_tdNodeData[0].iMax = 255;
	m_tdNodeData[0].iMin = 0;
	m_tdNodeData[0].iPos = 51; // 20%, which matches initial view value

	m_tdNodeData[1].strPropText = _T("Ambient light, green");
	m_tdNodeData[1].iProperty = LIGHT_AMBIENT;
	m_tdNodeData[1].iComponent = GREEN;
	m_tdNodeData[1].iMax = 255;
	m_tdNodeData[1].iMin = 0;
	m_tdNodeData[1].iPos = 51; // 20%, which matches initial view value

	m_tdNodeData[2].strPropText = _T("Ambient light, blue");
	m_tdNodeData[2].iProperty = LIGHT_AMBIENT;
	m_tdNodeData[2].iComponent = BLUE;
	m_tdNodeData[2].iMax = 255;
	m_tdNodeData[2].iMin = 0;
	m_tdNodeData[2].iPos = 51; // 20%, which matches initial view value

	m_tdNodeData[3].strPropText = _T("Diffuse light, red");
	m_tdNodeData[3].iProperty = LIGHT_DIFFUSE;
	m_tdNodeData[3].iComponent = RED;
	m_tdNodeData[3].iMax = 255;
	m_tdNodeData[3].iMin = 0;
	m_tdNodeData[3].iPos = 127; // 50%, which matches initial view value

	m_tdNodeData[4].strPropText = _T("Diffuse light, green");
	m_tdNodeData[4].iProperty = LIGHT_DIFFUSE;
	m_tdNodeData[4].iComponent = GREEN;
	m_tdNodeData[4].iMax = 255;
	m_tdNodeData[4].iMin = 0;
	m_tdNodeData[4].iPos = 127; // 50%, which matches initial view value

	m_tdNodeData[5].strPropText = _T("Diffuse light, blue");
	m_tdNodeData[5].iProperty = LIGHT_DIFFUSE;
	m_tdNodeData[5].iComponent = BLUE;
	m_tdNodeData[5].iMax = 255;
	m_tdNodeData[5].iMin = 0;
	m_tdNodeData[5].iPos = 127; // 50%, which matches initial view value

	m_tdNodeData[6].strPropText = _T("Specular light, red");
	m_tdNodeData[6].iProperty = LIGHT_SPECULAR;
	m_tdNodeData[6].iComponent = RED;
	m_tdNodeData[6].iMax = 255;
	m_tdNodeData[6].iMin = 0;
	m_tdNodeData[6].iPos = 0; // 0%, which matches initial view value

	m_tdNodeData[7].strPropText = _T("Specular light, green");
	m_tdNodeData[7].iProperty = LIGHT_SPECULAR;
	m_tdNodeData[7].iComponent = GREEN;
	m_tdNodeData[7].iMax = 255;
	m_tdNodeData[7].iMin = 0;
	m_tdNodeData[7].iPos = 0; // 0%, which matches initial view value

	m_tdNodeData[8].strPropText = _T("Specular light, blue");
	m_tdNodeData[8].iProperty = LIGHT_SPECULAR;
	m_tdNodeData[8].iComponent = BLUE;
	m_tdNodeData[8].iMax = 255;
	m_tdNodeData[8].iMin = 0;
	m_tdNodeData[8].iPos = 0; // 0%, which matches initial view value

	m_tdNodeData[9].strPropText = _T("Material ambient, red");
	m_tdNodeData[9].iProperty = MATERIAL_AMBIENT;
	m_tdNodeData[9].iComponent = RED;
	m_tdNodeData[9].iMax = 255;
	m_tdNodeData[9].iMin = 0;
	m_tdNodeData[9].iPos = 178; // 70%, which matches initial view value

	m_tdNodeData[10].strPropText = _T("Material ambient, green");
	m_tdNodeData[10].iProperty = MATERIAL_AMBIENT;
	m_tdNodeData[10].iComponent = GREEN;
	m_tdNodeData[10].iMax = 255;
	m_tdNodeData[10].iMin = 0;
	m_tdNodeData[10].iPos = 178; // 70%, which matches initial view value

	m_tdNodeData[11].strPropText = _T("Material ambient, blue");
	m_tdNodeData[11].iProperty = MATERIAL_AMBIENT;
	m_tdNodeData[11].iComponent = BLUE;
	m_tdNodeData[11].iMax = 255;
	m_tdNodeData[11].iMin = 0;
	m_tdNodeData[11].iPos = 178; // 70%, which matches initial view value

	m_tdNodeData[12].strPropText = _T("Material emitted, red");
	m_tdNodeData[12].iProperty = MATERIAL_EMITTED;
	m_tdNodeData[12].iComponent = RED;
	m_tdNodeData[12].iMax = 255;
	m_tdNodeData[12].iMin = 0;
	m_tdNodeData[12].iPos = 25; // 10%, which matches initial view value

	m_tdNodeData[13].strPropText = _T("Material emitted, green");
	m_tdNodeData[13].iProperty = MATERIAL_EMITTED;
	m_tdNodeData[13].iComponent = GREEN;
	m_tdNodeData[13].iMax = 255;
	m_tdNodeData[13].iMin = 0;
	m_tdNodeData[13].iPos = 25; // 10%, which matches initial view value

	m_tdNodeData[14].strPropText = _T("Material emitted, blue");
	m_tdNodeData[14].iProperty = MATERIAL_EMITTED;
	m_tdNodeData[14].iComponent = BLUE;
	m_tdNodeData[14].iMax = 255;
	m_tdNodeData[14].iMin = 0;
	m_tdNodeData[14].iPos = 25; // 10%, which matches initial view value

	m_tdNodeData[15].strPropText = _T("Material specular, red");
	m_tdNodeData[15].iProperty = MATERIAL_SPECULAR;
	m_tdNodeData[15].iComponent = RED;
	m_tdNodeData[15].iMax = 255;
	m_tdNodeData[15].iMin = 0;
	m_tdNodeData[15].iPos = 255; // 100%, which matches initial view value

	m_tdNodeData[16].strPropText = _T("Material specular, green");
	m_tdNodeData[16].iProperty = MATERIAL_SPECULAR;
	m_tdNodeData[16].iComponent = GREEN;
	m_tdNodeData[16].iMax = 255;
	m_tdNodeData[16].iMin = 0;
	m_tdNodeData[16].iPos = 255; // 100%, which matches initial view value

	m_tdNodeData[17].strPropText = _T("Material specular, blue");
	m_tdNodeData[17].iProperty = MATERIAL_SPECULAR;
	m_tdNodeData[17].iComponent = BLUE;
	m_tdNodeData[17].iMax = 255;
	m_tdNodeData[17].iMin = 0;
	m_tdNodeData[17].iPos = 255; // 100%, which matches initial view value

	m_tdNodeData[18].strPropText = _T("Material shininess");
	m_tdNodeData[18].iProperty = MATERIAL_SHININESS;
	m_tdNodeData[18].iComponent = BLUE;
	m_tdNodeData[18].iMax = 128;
	m_tdNodeData[18].iMin = 0;
	m_tdNodeData[18].iPos = 100; // matches initial view value
}

CLightPage::~CLightPage()
{
}

void CLightPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLightPage)
	DDX_Control(pDX, IDC_PROPSLIDER, m_CPropSlider);
	DDX_Control(pDX, IDC_PROPTREE, m_CPropertyTree);
	DDX_Text(pDX, IDC_PROPTEXT, m_strPropText);
	DDX_Text(pDX, IDC_MINTXT, m_strMinText);
	DDX_Text(pDX, IDC_POSTXT, m_strPositionText);
	DDX_Text(pDX, IDC_MAXTXT, m_strMaxText);
	DDX_Check(pDX, IDC_DOSPOT, m_bDoSpotlight);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CLightPage, CPropertyPage)
	//{{AFX_MSG_MAP(CLightPage)
	ON_WM_HSCROLL()
	ON_NOTIFY(TVN_SELCHANGED, IDC_PROPTREE, OnSelchangedPropTree)
	ON_BN_CLICKED(IDC_DOSPOT, OnDoSpot)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLightPage message handlers

BOOL CLightPage::OnSetActive() 
{
	// Fill tree control with property information
	m_CPropertyTree.DeleteAllItems(); // start clean...

	// Insert light properties
	HTREEITEM hRoot = m_CPropertyTree.InsertItem("Light Properties");
	HTREEITEM hProp = m_CPropertyTree.InsertItem("Ambient",hRoot);
	HTREEITEM hNode = m_CPropertyTree.InsertItem("Red",hProp);
	m_CPropertyTree.SetItemData(hNode,0); // index into property array
	hNode = m_CPropertyTree.InsertItem("Green",hProp);
	m_CPropertyTree.SetItemData(hNode,1);
	hNode = m_CPropertyTree.InsertItem("Blue",hProp);
	m_CPropertyTree.SetItemData(hNode,2);
	hProp = m_CPropertyTree.InsertItem("Diffuse",hRoot);
	hNode = m_CPropertyTree.InsertItem("Red",hProp);
	m_CPropertyTree.SetItemData(hNode,3);
	hNode = m_CPropertyTree.InsertItem("Green",hProp);
	m_CPropertyTree.SetItemData(hNode,4);
	hNode = m_CPropertyTree.InsertItem("Blue",hProp);
	m_CPropertyTree.SetItemData(hNode,5);
	hProp = m_CPropertyTree.InsertItem("Specular",hRoot);
	hNode = m_CPropertyTree.InsertItem("Red",hProp);
	m_CPropertyTree.SetItemData(hNode,6);
	hNode = m_CPropertyTree.InsertItem("Green",hProp);
	m_CPropertyTree.SetItemData(hNode,7);
	hNode = m_CPropertyTree.InsertItem("Blue",hProp);
	m_CPropertyTree.SetItemData(hNode,8);
	hRoot = m_CPropertyTree.InsertItem("Material Properties");
	hProp = m_CPropertyTree.InsertItem("Ambient",hRoot);
	hNode = m_CPropertyTree.InsertItem("Red",hProp);
	m_CPropertyTree.SetItemData(hNode,9);
	hNode = m_CPropertyTree.InsertItem("Green",hProp);
	m_CPropertyTree.SetItemData(hNode,10);
	hNode = m_CPropertyTree.InsertItem("Blue",hProp);
	m_CPropertyTree.SetItemData(hNode,11);
	hProp = m_CPropertyTree.InsertItem("Emitted",hRoot);
	hNode = m_CPropertyTree.InsertItem("Red",hProp);
	m_CPropertyTree.SetItemData(hNode,12);
	hNode = m_CPropertyTree.InsertItem("Green",hProp);
	m_CPropertyTree.SetItemData(hNode,13);
	hNode = m_CPropertyTree.InsertItem("Blue",hProp);
	m_CPropertyTree.SetItemData(hNode,14);
	hProp = m_CPropertyTree.InsertItem("Specular",hRoot);
	hNode = m_CPropertyTree.InsertItem("Red",hProp);
	m_CPropertyTree.SetItemData(hNode,15);
	hNode = m_CPropertyTree.InsertItem("Green",hProp);
	m_CPropertyTree.SetItemData(hNode,16);
	hNode = m_CPropertyTree.InsertItem("Blue",hProp);
	m_CPropertyTree.SetItemData(hNode,17);
	hProp = m_CPropertyTree.InsertItem("Shininess",hRoot);
	m_CPropertyTree.SetItemData(hProp,18);
	
	return CPropertyPage::OnSetActive();
}

void CLightPage::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// Obtain our view
	CMainFrame* pFrame = (CMainFrame*)AfxGetMainWnd();
	CGLObjectView* pView = (CGLObjectView*)pFrame->GetActiveView();
	ASSERT(pView != NULL);

	// Pull slider value and notify the view
	NMPROPSCHANGE msg;
	msg.hdr.hwndFrom = m_hWnd;
	msg.hdr.idFrom = IDD_LIGHT;
	msg.hdr.code = LIGHT_NOTIFY_PROPSCHANGE;
	if ( pScrollBar == (CScrollBar*)&m_CPropSlider ) {
		// Save current value
		m_tdNodeData[m_iCurrentIndex].iPos = m_CPropSlider.GetPos();

		// Update slider indicator
		m_strPositionText.Format("%d",m_tdNodeData[m_iCurrentIndex].iPos);
		UpdateData(FALSE);

		// Notify property change
		msg.iProperty = m_tdNodeData[m_iCurrentIndex].iProperty;
		msg.iComponent = m_tdNodeData[m_iCurrentIndex].iComponent;
		msg.fValue = (GLfloat)m_tdNodeData[m_iCurrentIndex].iPos;
		if ( msg.iProperty != MATERIAL_SHININESS ) {
			// Adjust RGB values from 0-255 to 0.0-1.0
			msg.fValue /= 255.0f;
		} // if
		pView->SendMessage(WM_NOTIFY,(WPARAM)IDD_LIGHT,(LPARAM)(&msg));
	} // if

	CPropertyPage::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CLightPage::OnSelchangedPropTree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;

	// Examine notification structure to determine new
	// selection
	if ( pNMTreeView->itemNew.mask & TVIF_HANDLE ) {
		// If the HTREEITEM member is valid...
		m_iCurrentIndex = (int)m_CPropertyTree.GetItemData(pNMTreeView->itemNew.hItem);

		// Pull parameter data and set controls accordingly
		m_strPropText = m_tdNodeData[m_iCurrentIndex].strPropText;
		m_CPropSlider.SetRange(m_tdNodeData[m_iCurrentIndex].iMin,m_tdNodeData[m_iCurrentIndex].iMax);
		m_CPropSlider.SetPos(m_tdNodeData[m_iCurrentIndex].iPos);
		m_strMinText.Format("(%d)",m_tdNodeData[m_iCurrentIndex].iMin);
		m_strPositionText.Format("%d",m_tdNodeData[m_iCurrentIndex].iPos);
		m_strMaxText.Format("(%d)",m_tdNodeData[m_iCurrentIndex].iMax);

		// Update controls
		UpdateData(FALSE);
	} // if
	
	*pResult = 0;
}

void CLightPage::OnDoSpot() 
{
	// Pull control value
	UpdateData(TRUE);

	// Obtain our view
	CMainFrame* pFrame = (CMainFrame*)AfxGetMainWnd();
	CGLObjectView* pView = (CGLObjectView*)pFrame->GetActiveView();
	ASSERT(pView != NULL);

	// Pull combo box value and notify the view
	NMSPOTCHANGE msg;
	msg.hdr.hwndFrom = m_hWnd;
	msg.hdr.idFrom = IDD_LIGHT;
	msg.hdr.code = LIGHT_NOTIFY_SPOTCHANGE;

	// Notify object change
	msg.bEnable = m_bDoSpotlight;
	pView->SendMessage(WM_NOTIFY,(WPARAM)IDD_LIGHT,(LPARAM)(&msg));
}
