#if !defined(AFX_LIGHTPAGE_H__F5C26FDC_9115_11D2_B21B_00C04FBEDB8F__INCLUDED_)
#define AFX_LIGHTPAGE_H__F5C26FDC_9115_11D2_B21B_00C04FBEDB8F__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// LightPage.h : header file
//

// OpenGL header
#include <gl\gl.h>

/////////////////////////////////////////////////////////////////////////////
// CLightPage notifications

#define LIGHT_AMBIENT		0
#define LIGHT_DIFFUSE		1
#define LIGHT_SPECULAR		2
#define MATERIAL_AMBIENT	3
#define MATERIAL_EMITTED	4
#define MATERIAL_SPECULAR	5
#define MATERIAL_SHININESS	6

#define RED		0
#define GREEN	1
#define BLUE	2

#define LIGHT_NOTIFY_PROPSCHANGE	412200
typedef struct tagPropsChange {
	// Property changed message
	NMHDR hdr;		// WM_NOTIFY message header
	int iProperty;	// id of selected property
	int iComponent;	// RGB component
	GLfloat fValue;	// new property value
} NMPROPSCHANGE, FAR* LPNMPROPSCHANGE;

#define LIGHT_NOTIFY_SPOTCHANGE	412210
typedef struct tagSpotChange {
	// Property changed message
	NMHDR hdr;		// WM_NOTIFY message header
	BOOL bEnable;	// enable status
} NMSPOTCHANGE, FAR* LPNMSPOTCHANGE;

/////////////////////////////////////////////////////////////////////////////
// CLightPage tree data structure

typedef struct tagTreeData {
	CString strPropText;	// the property text
	int iProperty;			// id of selected property
	int iComponent;			// RGB component
	int iMax;				// slider max 
	int iMin;				// slider min
	int iPos;				// slider initial position
} TREEDATA, FAR* LPTREEDATA;

/////////////////////////////////////////////////////////////////////////////
// CLightPage dialog

class CLightPage : public CPropertyPage
{
	DECLARE_DYNCREATE(CLightPage)

// Construction
public:
	CLightPage();
	~CLightPage();

// Dialog Data
	//{{AFX_DATA(CLightPage)
	enum { IDD = IDD_LIGHT };
	CSliderCtrl	m_CPropSlider;
	CTreeCtrl	m_CPropertyTree;
	CString	m_strPropText;
	CString	m_strMinText;
	CString	m_strPositionText;
	CString	m_strMaxText;
	BOOL	m_bDoSpotlight;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CLightPage)
	public:
	virtual BOOL OnSetActive();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	int m_iCurrentIndex;
	TREEDATA m_tdNodeData[19];

	// Generated message map functions
	//{{AFX_MSG(CLightPage)
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnSelchangedPropTree(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDoSpot();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_LIGHTPAGE_H__F5C26FDC_9115_11D2_B21B_00C04FBEDB8F__INCLUDED_)
