// MFCClientDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MFCClient.h"
#include "MFCClientDlg.h"
#include "..\ATLEncrypt\ATLEncrypt.h"
#include "..\ATLEncrypt\ATLEncrypt_i.c"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMFCClientDlg dialog

CMFCClientDlg::CMFCClientDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMFCClientDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMFCClientDlg)
	m_strOriginal = _T("");
	m_strMunged = _T("");
	m_strDecrypted = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMFCClientDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMFCClientDlg)
	DDX_Text(pDX, IDC_ORIGINAL, m_strOriginal);
	DDV_MaxChars(pDX, m_strOriginal, 32);
	DDX_Text(pDX, IDC_MUNGED, m_strMunged);
	DDX_Text(pDX, IDC_DECRYPTED, m_strDecrypted);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMFCClientDlg, CDialog)
	//{{AFX_MSG_MAP(CMFCClientDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_MUNGE, OnMunge)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMFCClientDlg message handlers

BOOL CMFCClientDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMFCClientDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMFCClientDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMFCClientDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMFCClientDlg::OnMunge() 
{
	// Load our variables
	UpdateData(TRUE);

	// Create our COM object
	CComPtr<IStringEncrypt> pEncrypt;
	HRESULT hr = CoCreateInstance(CLSID_StringEncrypt,
					NULL, // no aggregation
					CLSCTX_INPROC_SERVER,
					IID_IStringEncrypt,
					reinterpret_cast<void**>(&pEncrypt));
	if ( FAILED(hr) ) {
		// Problem creating the COM object...
		AfxMessageBox("Error creating encryption object",MB_OK | MB_ICONERROR);
		return;
	} // if

	// Now we have our COM object, we create some BSTRs and call it
	CComBSTR bstrClearText(m_strOriginal);
	CComBSTR bstrMunged;
	hr = pEncrypt->Encrypt(bstrClearText,&bstrMunged);
	if ( FAILED(hr) ) {
		// Problem creating the COM object...
		AfxMessageBox("Error encrypting string!",MB_OK | MB_ICONERROR);
		return;
	} // if

	// The object has now encrypted our password, so we feed it back
	// in to decrypt.
	CComBSTR bstrDecrypted;
	pEncrypt->Decrypt(bstrMunged,&bstrDecrypted);
	if ( FAILED(hr) ) {
		// Problem creating the COM object...
		AfxMessageBox("Error decrypting string!",MB_OK | MB_ICONERROR);
		return;
	} // if

	// Now, we pull the string values out
	m_strMunged = bstrMunged;
	m_strDecrypted = bstrDecrypted;

	// Finally, we update our control windows
	UpdateData(FALSE);
}
