// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "WebApp.h"

#include "WebView.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
	ON_CBN_SELENDOK(AFX_IDW_TOOLBAR + 1,OnSelEndOKURL)
	ON_COMMAND(IDOK, OnNewURLEnter)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	// Create the URL combo box
	if (!m_wndURL.Create(CBS_DROPDOWN | WS_CHILD,CRect(0,0,200,120),this,AFX_IDW_TOOLBAR + 1))
	{
		TRACE0("Failed to create combobox\n");
		return -1;      // fail to create
	}


	if (!m_wndReBar.Create(this) ||
		!m_wndReBar.AddBar(&m_wndToolBar) ||
		!m_wndReBar.AddBar(&m_wndURL,_T("Address:"),NULL,RBBS_FIXEDBMP | RBBS_BREAK))
	{
		TRACE0("Failed to create rebar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Remove this if you don't want tool tips
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY);

	if (!m_wndTreeBar.Create(this, IDD_DHTMLTREE,
		CBRS_LEFT | CBRS_TOOLTIPS | CBRS_FLYBY, IDD_DHTMLTREE))
	{
		TRACE0("Failed to create Dialog Bar\n");
		return -1;		// fail to create
	}
	m_wndTreeBar.EnableDocking(CBRS_ALIGN_LEFT | CBRS_ALIGN_RIGHT);
	EnableDocking(CBRS_ALIGN_LEFT | CBRS_ALIGN_RIGHT);
	DockControlBar(&m_wndTreeBar);
	m_wndTreeBar.UpdateData(FALSE); // subclass the tree control!

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// No auto-title...
	cs.style &= ~FWS_ADDTOTITLE;

	return CFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::UpdateTree(LPDISPATCH pDocDispatch, LPCTSTR strHtmFile)
{
	// Delegate to the dialog bar...
	ASSERT(pDocDispatch != NULL);
	m_wndTreeBar.UpdateTree(pDocDispatch);

	// Update the window's title
	CString strWndText;
	strWndText.Format("%s: \"%s\"",strHtmFile,m_wndTreeBar.GetTitle());
	SetWindowText(strWndText);
}

void CMainFrame::SetURL(LPCTSTR lpszUrl)
{
	// Update the URL
	m_wndURL.SetWindowText(lpszUrl);

	// Add the text to the list control
	COMBOBOXEXITEM cbItem;
	cbItem.mask = CBEIF_TEXT;
	cbItem.iItem = -1;
	cbItem.pszText = (LPTSTR)lpszUrl;
	m_wndURL.InsertItem(&cbItem);
}

void CMainFrame::OnSelEndOKURL()
{
	// A stored URL was selected, so navigate there
	CString strURL;

	m_wndURL.GetLBText(m_wndURL.GetCurSel(),strURL);
	CWebView* pView = (CWebView*)GetActiveView();
	ASSERT(pView);
	pView->Navigate2(strURL,NULL,NULL);
}

void CMainFrame::OnNewURLEnter()
{
	// A URL was manually entered, so navigate there
	CString strURL;

	m_wndURL.GetEditCtrl()->GetWindowText(strURL);
	CWebView* pView = (CWebView*)GetActiveView();
	ASSERT(pView);
	pView->Navigate2(strURL,NULL,NULL);

	// Add the text to the list control
	COMBOBOXEXITEM cbItem;
	cbItem.mask = CBEIF_TEXT;
	cbItem.iItem = -1;
	cbItem.pszText = (LPTSTR)strURL.GetBuffer(0);
	m_wndURL.InsertItem(&cbItem);
}
