// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "DocNavigator.h"

#include "MainFrm.h"
#include "SplitTreeView.h"
#include "DocNavigatorView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CSplitFrame)

BEGIN_MESSAGE_MAP(CMainFrame, CSplitFrame)
	//{{AFX_MSG_MAP(CMainFrame)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
	ON_CBN_SELENDOK(AFX_IDW_TOOLBAR + 1,OnSelEndOKURL)
	ON_COMMAND(IDOK, OnNewURLEnter)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame() :
	CSplitFrame(RUNTIME_CLASS(CSplitTreeView),RUNTIME_CLASS(CDocNavigatorView))
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CSplitFrame::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	// Create the URL combo box
	if (!m_wndURL.Create(CBS_DROPDOWN | WS_CHILD,CRect(0,0,200,120),this,AFX_IDW_TOOLBAR + 1))
	{
		TRACE0("Failed to create combobox\n");
		return -1;      // fail to create
	}

	if (!m_wndReBar.Create(this) ||
		!m_wndReBar.AddBar(&m_wndToolBar) ||
		!m_wndReBar.AddBar(&m_wndURL,_T("Address:"),NULL,RBBS_FIXEDBMP | RBBS_BREAK))
	{
		TRACE0("Failed to create rebar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Remove this if you don't want tool tips
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// No auto-title...
	cs.style &= ~FWS_ADDTOTITLE;

	return CFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CSplitFrame::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CSplitFrame::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::Navigate(LPCTSTR strItem)
{
	// The tree view is asking the web browser view to navigate to
	// the URL stored in the parameter.  We'll ask the splitter
	// window to give us the CWnd-based pointer for the web
	// view, which we'll use to tell the Web Browser control to
	// navigate for us...
	CDocNavigatorView* pWebView = reinterpret_cast<CDocNavigatorView*>(RetrieveView(2));
	ASSERT(pWebView != NULL);
	pWebView->NavigateAnchor(strItem);
}

void CMainFrame::UpdateTree(LPDISPATCH pDocDispatch, LPCTSTR strHtmFile)
{
	// Delegate to the dialog bar...
	ASSERT(pDocDispatch != NULL);
	CSplitTreeView* pTreeView = reinterpret_cast<CSplitTreeView*>(RetrieveView(1));
	ASSERT(pTreeView != NULL);
	pTreeView->UpdateTree(pDocDispatch);

	// Update the window's title
	SetWindowText(strHtmFile);
}

void CMainFrame::SetURL(LPCTSTR lpszUrl)
{
	// Update the URL
	m_wndURL.SetWindowText(lpszUrl);

	// Add the text to the list control
	if ( m_wndURL.FindString(-1,lpszUrl) == CB_ERR ) {
		// ...IF the string isnt' already there.
		m_wndURL.AddString(lpszUrl);
	} // if
}

void CMainFrame::BrowseURL()
{
	// Load a file.  The tree view calls this method in
	// lieu of the default file loading mechanism.
	CDocNavigatorView* pWebView = reinterpret_cast<CDocNavigatorView*>(RetrieveView(2));
	ASSERT(pWebView != NULL);
	pWebView->BrowseURL();
}

void CMainFrame::PrintURL()
{
	// Print the document.  The tree view calls this method in
	// lieu of the default file printing mechanism.
	CHtmlView* pWebView = reinterpret_cast<CHtmlView*>(RetrieveView(2));
	ASSERT(pWebView != NULL);
	pWebView->OnFilePrint();
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnSelEndOKURL()
{
	// A stored URL was selected, so navigate there
	CString strURL;

	m_wndURL.GetLBText(m_wndURL.GetCurSel(),strURL);
	CDocNavigatorView* pWebView = reinterpret_cast<CDocNavigatorView*>(RetrieveView(2));
	ASSERT(pWebView != NULL);
	pWebView->LoadURL(strURL);
}

void CMainFrame::OnNewURLEnter()
{
	// A URL was manually entered, so navigate there
	CString strURL;

	m_wndURL.GetWindowText(strURL);
	CDocNavigatorView* pWebView = reinterpret_cast<CDocNavigatorView*>(RetrieveView(2));
	ASSERT(pWebView != NULL);
	pWebView->LoadURL(strURL);

	// Add the text to the list control...
	if ( m_wndURL.FindString(-1,strURL) == CB_ERR ) {
		// ...IF the string isnt' already there.
		m_wndURL.AddString(strURL);
	} // if
}


