// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINFRM_H__F8FA894A_ACC1_11D2_8329_E299EDB97E13__INCLUDED_)
#define AFX_MAINFRM_H__F8FA894A_ACC1_11D2_8329_E299EDB97E13__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#import "../AppObject/AppObject.tlb" no_namespace named_guids
#import "../ScriptObject/ScriptObject.tlb" no_namespace named_guids

class CMainFrame : public CFrameWnd
{
	
protected: // create from serialization only
	CMainFrame();
	DECLARE_DYNCREATE(CMainFrame)

// Attributes
public:

// Operations
public:
	IAppObject* GetAppObject() { return m_pAppObject.GetInterfacePtr(); }
	HRESULT AddDocObject(BSTR bstrName, IDispatch* pIDispatch);
	HRESULT AddTextSelObject(BSTR bstrName, IDispatch* pIDispatch);
	void RunMacro(LPCTSTR strText);
	void LoadMacro(const CString& strMacroFile, CString& strMacroText);

protected:
	void FillMacroBox();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void ActivateFrame(int nCmdShow = -1);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:  // control bar embedded members
	CStatusBar  m_wndStatusBar;
	CToolBar    m_wndToolBar;
	CReBar      m_wndReBar;
	CComboBox   m_wndMacro;

	// COM Objects
	IScriptObjectPtr m_pScriptObject;
	IAppObjectPtr	m_pAppObject;

// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnMacroNew();
	afx_msg void OnMacroRun();
	afx_msg void OnMacroEdit();
	afx_msg void OnMacroReset();
	//}}AFX_MSG
	afx_msg void OnSelchangeMacro();
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__F8FA894A_ACC1_11D2_8329_E299EDB97E13__INCLUDED_)
