// MyInternetSession.cpp: implementation of the CMyInternetSession class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "InetSession.h"
#include "MyInternetSession.h"
#include "InetSessionDlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CMyInternetSession::CMyInternetSession()
{

}

CMyInternetSession::~CMyInternetSession()
{

}

void CMyInternetSession::OnStatusCallback(DWORD dwContext, DWORD dwInternetStatus, LPVOID lpvStatusInformation, DWORD dwStatusInformationLength)
{
	// Get the MFC module state (this is required)
	AFX_MANAGE_STATE(AfxGetAppModuleState());

	CString sNewStatus;
	CString sStatusInfo((LPCSTR)lpvStatusInformation);

	// Do we have a valid pointer to the parent dialog?
	if (m_pParentDialog)
	{
		// What's the new status of the Internet Session?
		switch (dwInternetStatus)
		{
		// Resolving the server name
		case INTERNET_STATUS_RESOLVING_NAME:
			if (dwStatusInformationLength > 0)
				sNewStatus = "Resolving name - " + sStatusInfo;
			else
				sNewStatus = "Resolving name";
			break;

		// Server name has been resolved
		case INTERNET_STATUS_NAME_RESOLVED:
			if (dwStatusInformationLength > 0)
				sNewStatus = "Name resolved - " + sStatusInfo;
			else
				sNewStatus = "Name resolved";
			break;

		// Connecting to the server
		case INTERNET_STATUS_CONNECTING_TO_SERVER:
			sNewStatus = "Connecting to server";
			break;

		// Connected to the server
		case INTERNET_STATUS_CONNECTED_TO_SERVER:
			sNewStatus = "Connected to server";
			break;

		// Sending the request
		case INTERNET_STATUS_SENDING_REQUEST:
			sNewStatus = "Sending request";
			break;

		// Request has been sent
		case INTERNET_STATUS_REQUEST_SENT:
			sNewStatus = "Request sent";
			break;

		// Receiving the response from the server
		case INTERNET_STATUS_RECEIVING_RESPONSE:
			sNewStatus = "Receiving response";
			break;

		// The response has been received
		case INTERNET_STATUS_RESPONSE_RECEIVED:
			sNewStatus = "Response received";
			break;

		// Closing the connection
		case INTERNET_STATUS_CLOSING_CONNECTION:
			sNewStatus = "Closing connection";
			break;

		// The connection has been closed
		case INTERNET_STATUS_CONNECTION_CLOSED:
			sNewStatus = "Connection closed";
			break;

		// A handle to the Internet Status has been created
		case INTERNET_STATUS_HANDLE_CREATED:
			sNewStatus = "Handle created";
			break;

		// Closing the handle of the Status
		case INTERNET_STATUS_HANDLE_CLOSING:
			sNewStatus = "Closing handle";
			break;

		// Status request has been completed
		case INTERNET_STATUS_REQUEST_COMPLETE:
			sNewStatus = "Request complete";
			break;

		// Unknown status code
		default:
			sNewStatus = "Unknown Status";
			break;
		}
		// Update the dialog with the new status
		m_pParentDialog->UpdateStatus(sNewStatus);
	}
}

void CMyInternetSession::SetParentDialog(CInetSessionDlg *pParentDialog)
{
	// Set the parent dialog pointer
	m_pParentDialog = pParentDialog;
}
