#if !defined(AFX_OBJECTPAGE_H__F5C26FDD_9115_11D2_B21B_00C04FBEDB8F__INCLUDED_)
#define AFX_OBJECTPAGE_H__F5C26FDD_9115_11D2_B21B_00C04FBEDB8F__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// ObjectPage.h : header file
//

// OpenGL header
#include <gl\gl.h>

/////////////////////////////////////////////////////////////////////////////
// CObjectPage notifications

#define OBJECT_NOTIFY_OBJECTCHANGE	412100
typedef struct tagObjectChange {
	// Object changed message
	NMHDR hdr;		// WM_NOTIFY message header
	int iValue;		// new object number
} NMOBJECTCHANGE, FAR* LPNMOBJECTCHANGE;

#define OBJECT_NOTIFY_RENDERCHANGE	412110
typedef struct tagRenderChange {
	// Render type changed message
	NMHDR hdr;		// WM_NOTIFY message header
	int iValue;		// new render type
} NMRENDERCHANGE, FAR* LPNMRENDERCHANGE;

#define SCALEX	0
#define SCALEY	1
#define SCALEZ	2

#define OBJECT_NOTIFY_SCALECHANGE	412120
typedef struct tagScaleChange {
	// Scale changed message
	NMHDR hdr;		// WM_NOTIFY message header
	int iAxis;		// id of selected axis
	GLfloat fValue;	// new scale value
} NMSCALECHANGE, FAR* LPNMSCALECHANGE;

#define OBJECT_NOTIFY_AXESCHANGE	412130
typedef struct tagAxesChange {
	// Axes changed message
	NMHDR hdr;		// WM_NOTIFY message header
	BOOL bEnable;	// enabled status
} NMAXESCHANGE, FAR* LPNMAXESCHANGE;

/////////////////////////////////////////////////////////////////////////////
// CObjectPage dialog

class CObjectPage : public CPropertyPage
{
	DECLARE_DYNCREATE(CObjectPage)

// Construction
public:
	CObjectPage();
	~CObjectPage();

// Dialog Data
	//{{AFX_DATA(CObjectPage)
	enum { IDD = IDD_OBJECT };
	CSliderCtrl	m_CScaleZ;
	CSliderCtrl	m_CScaleY;
	CSliderCtrl	m_CScaleX;
	CComboBox	m_CObjectBox;
	int		m_iRenderStyle;
	BOOL	m_bDrawAxes;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CObjectPage)
	public:
	virtual BOOL OnSetActive();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CObjectPage)
	afx_msg void OnRenderChange();
	afx_msg void OnSelchangeObject();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnDoAxes();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_OBJECTPAGE_H__F5C26FDD_9115_11D2_B21B_00C04FBEDB8F__INCLUDED_)
