// ScriptView.h : interface of the CScriptView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_SCRIPTVIEW_H__F8FA894E_ACC1_11D2_8329_E299EDB97E13__INCLUDED_)
#define AFX_SCRIPTVIEW_H__F8FA894E_ACC1_11D2_8329_E299EDB97E13__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#import "../DocObject/DocObject.tlb" no_namespace named_guids
#import "../TextObject/TextObject.tlb" no_namespace named_guids

class CScriptDoc;

class CScriptView : public CEditView
{
protected: // create from serialization only
	CScriptView();
	DECLARE_DYNCREATE(CScriptView)

// Attributes
public:
	CScriptDoc* GetDocument();

// Operations
public:
	void InitializeObjects();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CScriptView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CScriptView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	// Our script COM objects
	IDocObjectPtr m_pDocObject;
	ITextSelObjectPtr m_pTextSelObject;

// Generated message map functions
protected:
	//{{AFX_MSG(CScriptView)
	afx_msg void OnFileSave();
	afx_msg void OnFileSaveAs();
	afx_msg void OnFileOpen();
	afx_msg void OnFileNew();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in ScriptView.cpp
inline CScriptDoc* CScriptView::GetDocument()
   { return (CScriptDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SCRIPTVIEW_H__F8FA894E_ACC1_11D2_8329_E299EDB97E13__INCLUDED_)
