#include <activscp.h>

class ATL_NO_VTABLE IActiveScriptSiteImpl : public IActiveScriptSite
{
	STDMETHOD(QueryInterface)(REFIID riid, void ** ppvObject) = 0;
	_ATL_DEBUG_ADDREF_RELEASE_IMPL(IActiveScriptSiteImpl)

	STDMETHOD(GetItemInfo)(LPCOLESTR pstrName, DWORD dwReturnMask,
		IUnknown **ppiunkItem, ITypeInfo **ppti)
	{ return E_FAIL; }
 
	STDMETHOD(OnScriptError)(IActiveScriptError *pscripterror)
	{
		DWORD dwCookie;
		LONG nChar;
		ULONG nLine;
		BSTR bstr = 0;
		EXCEPINFO ei; ZeroMemory(&ei, sizeof(ei));
		pscripterror->GetSourcePosition(&dwCookie, &nLine, &nChar);
		pscripterror->GetSourceLineText(&bstr);
		pscripterror->GetExceptionInfo(&ei);
    
		OLECHAR wszOutput[1024];
		swprintf(wszOutput, OLESTR("%s\n[Line: %d] %s\n%s"),
				  ei.bstrSource, nLine, ei.bstrDescription,
				  bstr ? bstr : OLESTR(""));

		SysFreeString(bstr);
		SysFreeString(ei.bstrSource);
		SysFreeString(ei.bstrDescription);
		SysFreeString(ei.bstrHelpFile);
		MessageBoxW(GetDesktopWindow(),
					wszOutput,
					L"Error",
					MB_SETFOREGROUND);

		return S_OK;
	}

	STDMETHOD(GetLCID)(LCID *plcid)
	{ *plcid = 9; return S_OK; }

	STDMETHOD(GetDocVersionString)(BSTR *pbstrVersion) 
	{ *pbstrVersion = SysAllocString(L""); return S_OK; }

	STDMETHOD(OnScriptTerminate)(const VARIANT *pvr, const EXCEPINFO *pei)
	{ return S_OK; }

	STDMETHOD(OnStateChange)(SCRIPTSTATE ssScriptState)
	{ return S_OK; }

	STDMETHOD(OnEnterScript)(void)
	{ return S_OK; }

	STDMETHODIMP OnLeaveScript(void) 
	{ return S_OK; }
};

class IActiveScriptSiteWindowImpl : public IActiveScriptSiteWindow
{
	STDMETHOD(QueryInterface)(REFIID riid, void ** ppvObject) = 0;
	_ATL_DEBUG_ADDREF_RELEASE_IMPL(IActiveScriptSiteImpl)

	STDMETHODIMP GetWindow(HWND *phwnd)
	{ *phwnd = GetDesktopWindow(); return S_OK; }

	STDMETHODIMP EnableModeless(BOOL)
	{ return S_OK; }
};