// TableView.h : interface of the CTableView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_TABLEVIEW_H__BDD2D54B_9F40_11D2_8329_B912F313131A__INCLUDED_)
#define AFX_TABLEVIEW_H__BDD2D54B_9F40_11D2_8329_B912F313131A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// DirectDraw header file
#include "ddraw.h"

// Game definitions
#define NUMCARDS	52
#define NUMCARDSINSUIT	13
#define CARDXPOS	110
#define DEALERYPOS	20
#define PLAYERYPOS	180
#define CARDWIDTH	71
#define CARDHEIGHT	96
#define CARDOFFSET	15

/////////////////////////////////////////////////////////////////////////////
// CTableView window

class CTableView : public CWnd
{
// Construction
public:
	CTableView();

// Attributes
public:

// Operations
public:

protected:
	// TableView.cpp
	BOOL RePalettize();

	// TableViewDDraw.cpp
	HRESULT CreateSecondarySurface(int cx, int cy, IDirectDrawSurface** ppDDS);
	HRESULT LoadDDBitmap(UINT nID, IDirectDrawSurface** ppDDS);
	HRESULT CopyDDBitmap(CBitmap* pbmImage, IDirectDrawSurface* pDDS);
	HRESULT ReLoadDDBitmap(UINT nID, IDirectDrawSurface* pDDS);
	HRESULT LoadDDPalette(UINT idBitmap, IDirectDrawPalette** ppDDP);
	HRESULT Blt();

	// GameLogic.cpp
	enum Winner { Bust = 0, Dealer, Player };
	HRESULT ShowCards( BOOL bShowDealerHand = FALSE );
	void DealPlayer();
	void DealDealer();
	BOOL Reset();
	void Shuffle();
	BOOL Move();
	BOOL IsWinner();
	int HandValue( BOOL bIsDealer );
	void ProcessWinner( Winner wnWinner = Bust );

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTableView)
	protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CTableView();

// Generated message map functions
protected:
	// Cards
	int m_iCardDeck[NUMCARDS];
	int m_iCurrentCard;
	int m_iDealerHand[NUMCARDS];
	int m_iDealerNumCards;
	BOOL m_bDealerHolds;
	int m_iPlayerHand[NUMCARDS];
	int m_iPlayerNumCards;
	BOOL m_bPlayerHolds;

	// Moves
	enum Moves { NoDecision = 0, StandPat, HitMe };
	Moves m_mvLastDecision;

	// Our DirectDraw object
	// See OnDestroy() for discussion.
	CComPtr<IDirectDraw> m_pIDirectDraw;

	// Our DirectDraw palette
	CComPtr<IDirectDrawPalette> m_lpDDPalette;

	// Our DirectDraw surfaces
	CComPtr<IDirectDrawSurface> m_lpDDSPrimary;
	CComPtr<IDirectDrawSurface> m_lpDDSSecondary;
	CComPtr<IDirectDrawSurface> m_lpDDSCards1;
	CComPtr<IDirectDrawSurface> m_lpDDSCards2;
	CComPtr<IDirectDrawSurface> m_lpDDSCardBack;
	CComPtr<IDirectDrawSurface> m_lpDDSTable;

	//{{AFX_MSG(CTableView)
	afx_msg void OnPaint();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnMoveStandpat();
	afx_msg void OnMoveHitme();
	afx_msg void OnMoveNewGame();
	//}}AFX_MSG
	afx_msg void OnPaletteChanged(CWnd* pFocusWnd);
	afx_msg BOOL OnQueryNewPalette();
	afx_msg void OnDestroy();
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TABLEVIEW_H__BDD2D54B_9F40_11D2_8329_B912F313131A__INCLUDED_)
