// TextSelObjectCtl.h : Declaration of the CTextSelObject

#ifndef __TEXTSELOBJECT_H_
#define __TEXTSELOBJECT_H_

#include "resource.h"       // main symbols
#include "TextObjectCP.h"

/////////////////////////////////////////////////////////////////////////////
// CTextSelObject
class ATL_NO_VTABLE CTextSelObject : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CTextSelObject, &CLSID_TextSelObject>,
	public ISupportErrorInfo,
	public IConnectionPointContainerImpl<CTextSelObject>,
	public IDispatchImpl<ITextSelObject, &IID_ITextSelObject, &LIBID_TEXTOBJECTLib>,
	public IObjectSafetyImpl<CTextSelObject, INTERFACESAFE_FOR_UNTRUSTED_CALLER|INTERFACESAFE_FOR_UNTRUSTED_DATA>,
	public CProxy_ITextSelObjectEvents< CTextSelObject >,
	public CComControl<CTextSelObject>,
	public IProvideClassInfo2Impl<&CLSID_TextSelObject, &DIID__ITextSelObjectEvents>
	{
public:
	CTextSelObject() :
		m_hWndEdit(NULL),
		m_CEditCtrl(NULL,this,1)
	{
	}

	void FinalRelease()
	{
		// Unsubclass the edit control
		m_CEditCtrl.UnsubclassWindow();
	}

DECLARE_REGISTRY_RESOURCEID(IDR_TEXTSELOBJECT)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CTextSelObject)
	COM_INTERFACE_ENTRY(ITextSelObject)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY(IObjectSafety)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
	COM_INTERFACE_ENTRY_IMPL(IConnectionPointContainer)
END_COM_MAP()

BEGIN_CONNECTION_POINT_MAP(CTextSelObject)
	CONNECTION_POINT_ENTRY(DIID__ITextSelObjectEvents)
END_CONNECTION_POINT_MAP()

BEGIN_MSG_MAP(CDocObject)
	// Message map
ALT_MSG_MAP(1)
	// Alternate message map
	MESSAGE_HANDLER(WM_CHAR, OnChar)
END_MSG_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// ITextSelObject
public:
	STDMETHOD(InitHwnd)(/*[in]*/ OLE_HANDLE hWnd);
	STDMETHOD(ClearSelection)();
	STDMETHOD(ClearAll)();
	STDMETHOD(InsertText)(/*[in]*/ VARIANT newVal);
	STDMETHOD(SelectRange)(/*[in]*/ VARIANT lowerVal, /*[in]*/ VARIANT upperVal);
	STDMETHOD(SelectAll)();
	STDMETHOD(Paste)();
	STDMETHOD(Copy)();
	STDMETHOD(Cut)();
	STDMETHOD(SetCursorPos)(/*[in]*/ VARIANT lineVal, /*[in]*/ VARIANT indexVal);
	STDMETHOD(GetCursorPos)(/*[out]*/ VARIANT *pLineVal, /*[out]*/ VARIANT *pIndexVal);
	STDMETHOD(SetDocument)(/*[in]*/ LPDISPATCH newVal);
	STDMETHOD(SetApplication)(/*[in]*/ LPDISPATCH newVal);
	STDMETHOD(get_LowerSelBound)(/*[out, retval]*/ VARIANT *pVal);
	STDMETHOD(put_LowerSelBound)(/*[in]*/ VARIANT newVal);
	STDMETHOD(get_UpperSelBound)(/*[out, retval]*/ VARIANT *pVal);
	STDMETHOD(put_UpperSelBound)(/*[in]*/ VARIANT newVal);
	STDMETHOD(get_Document)(/*[out, retval]*/ VARIANT *pVal);
	STDMETHOD(get_Application)(/*[out, retval]*/ VARIANT *pVal);

// Subclassed edit control message handlers
protected:
	LRESULT OnChar(UINT, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		// Fire our event
		Fire_KeyPressed();

		// Allow the control to handle the character
		return m_CEditCtrl.DefWindowProc(WM_CHAR,wParam,lParam);
	}

// Attributes
protected:
	CComPtr<IDispatch> m_pAppObject;
	CComPtr<IDispatch> m_pDocObject;
	HWND m_hWndEdit;
	CContainedWindow m_CEditCtrl;
};

#endif //__TEXTSELOBJECT_H_
