// ToggleSplitWnd.cpp : implementation of the CToggleSplitWnd class
//

#include "stdafx.h"
#include "DocNavigator.h"

#include "ToggleSplitWnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CToggleSplitWnd

CToggleSplitWnd::CToggleSplitWnd()
{
	// TODO: add member initialization code here

}

BOOL CToggleSplitWnd::CreateStatic(CWnd* pParentWnd, int nRows, int nCols)
{
	// Some basic checks...
	ASSERT(pParentWnd != NULL);
	ASSERT(nCols > 1 || nRows > 1); // 1x1 is not permitted
	m_nMaxCols = 2; 
	m_nMaxRows = 2;
	ASSERT( nRows > 0 && nRows <= m_nMaxRows );
	ASSERT( nCols > 0 && nCols <= m_nMaxCols );

	// Assign members
	m_nRows = nRows;
	m_nCols = nCols;

	// Create with zero minimum pane size
	if ( !CreateCommon(pParentWnd,CSize(0,0),WS_CHILD | WS_VISIBLE,AFX_IDW_PANE_FIRST) ) {
		// Some problem, quit...
		return FALSE;
	} // if

	// All panes must be created with explicit calls to CreateView!!!
	return TRUE;
}

void CToggleSplitWnd::Toggle()
{
	// Adjust panes
	if ( BarIsHorizontal() ) {
		// Make vertical views...
		SetWindowLong(GetPane(1,0)->m_hWnd,GWL_ID,AFX_IDW_PANE_FIRST+1);
		m_nRows = 1;
		m_nCols = 2;
	} // if
	else {
		// Make horizontal views...
		SetWindowLong(GetPane(0,1)->m_hWnd,GWL_ID,AFX_IDW_PANE_FIRST+16);
		m_nRows = 2;
		m_nCols = 1;
	} // else
}

void CToggleSplitWnd::UpdateSizes(CSize& sPane1, CSize& sPane2)
{
	int nTemp, nMin;

	// Calculate the new sizing...
	if ( BarIsHorizontal() ) {
		GetRowInfo(0,nTemp,nMin);
		SetRowInfo(0,sPane1.cy,nMin);
		GetRowInfo(1,nTemp,nMin);
		SetRowInfo(1,sPane2.cy,nMin);
	} // if
	else {
		GetColumnInfo(0,nTemp,nMin);
		SetColumnInfo(0,sPane1.cx,nMin);
		GetColumnInfo(1,nTemp,nMin);
		SetColumnInfo(1,sPane2.cx,nMin);
	} // else

	// Establish the new sizing...
	RecalcLayout();
}

