// TreeBar.cpp : implementation file
//

#include "stdafx.h"
#include "WebApp.h"
#include "TreeBar.h"

// DHTML definitions
#include "MSHTML.H"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTreeBar dialog


CTreeBar::CTreeBar() : CDialogBar()
{
	//{{AFX_DATA_INIT(CTreeBar)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CTreeBar::DoDataExchange(CDataExchange* pDX)
{
	CDialogBar::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTreeBar)
	DDX_Control(pDX, IDC_DHTMLTREE, m_CDHTMLTree);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTreeBar, CDialogBar)
	//{{AFX_MSG_MAP(CTreeBar)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTreeBar message handlers

void CTreeBar::UpdateTree(LPDISPATCH pDocDispatch) 
{
	// Clear the tree control
	m_CDHTMLTree.DeleteAllItems();

	// Declare lists
	CStringList stlGeneric;
	CStringList stlImages;
	CStringList stlAnchors;
	CStringList stlUList;
	CStringList stlOList;
	CStringList stlCells;
	int iNumParagraphs = 0;
	int iNumFonts = 0;
	int iNumTables = 0;
	BOOL bOrderedList = TRUE;

	// Check to see that we do have a document.  The
	// HTML document pointer will be NULL if the
	// browser was unable to load the HTML file.
	if ( pDocDispatch != NULL ) {
		// We have a document, so now query for the
		// IHTMLDocument2 interface
		CComQIPtr<IHTMLDocument2,&IID_IHTMLDocument2> pHTMLDocument2(pDocDispatch);
		if ( pHTMLDocument2.p != NULL ) {
			// We have an active document, so retrieve the
			// anchor element collection.
			CComPtr<IHTMLElementCollection> pElements;
			HRESULT hr = pHTMLDocument2->get_all(&pElements);
			if ( SUCCEEDED(hr) ) {
				// Pull the elements and insert into the string
				// list.
				long iNumElements;
				hr = pElements->get_length(&iNumElements);
				if ( SUCCEEDED(hr) && iNumElements ) {

					// Loop through the number of items
					// and pull its IHTMLElement interface
					// pointer.
					for ( long i = 0; i < iNumElements; i++ ) {
						// Retrieve item in collection
						CComVariant varName(i);
						varName.ChangeType(VT_UINT);
						CComVariant varIndex;
						CComPtr<IDispatch> pDisp; 
						hr = pElements->item(varName,varIndex,&pDisp);
						if ( SUCCEEDED(hr) ) {
							// We have the element, so retrieve its
							// tag name.
							CComQIPtr<IHTMLElement,
								&IID_IHTMLElement> pElement(pDisp);
							if ( pElement != NULL ) {
								// Pull the tag string
								CString strTag;
								CComBSTR bstrTag;
								hr = pElement->get_tagName(&bstrTag);
								if ( !bstrTag ) {
									strTag = _T("???");
								} // if
								else {
									strTag = bstrTag.m_str;
								} // else

								// Determine the tag and pull
								// additional info depending...
								if ( !strTag.CompareNoCase("A") ) {
									// Anchor
									CComBSTR bstrAnchor;
									CComQIPtr<IHTMLAnchorElement,
										&IID_IHTMLAnchorElement> pAnchor(pDisp);
									if ( pAnchor ) {
										// Was a link...
										pAnchor->get_href(&bstrAnchor);
										if ( !bstrAnchor ) {
											// Could be a name instead
											// of a link...
											pAnchor->get_name(&bstrAnchor);
										} // if
										if ( !bstrAnchor ) {
											// Now I have no idea!
											bstrAnchor = _T("???");
										} // if
										CString strAnchor;
										strAnchor = bstrAnchor.m_str;
										stlAnchors.AddTail(strAnchor);
										continue;
									} // if
								} // if
								else if ( !strTag.CompareNoCase("TITLE") ) {
									// Title
									CComBSTR bstrText;
									CComQIPtr<IHTMLTitleElement,
										&IID_IHTMLTitleElement> pTitle(pDisp);
									if ( pTitle ) {
										pTitle->get_text(&bstrText);
										if ( !bstrText ) {
											// Don't know...
											bstrText = _T("???");
										} // if
									} // if

									// Insert into string
									m_strTitle = bstrText.m_str;
								} // else if
								else if ( !strTag.CompareNoCase("IMG") ) {
									// Try an image
									CComQIPtr<IHTMLImgElement,
										&IID_IHTMLImgElement> pImage(pDisp);
									if ( pImage ) {
										// Was an image...
										CComBSTR bstrImage;
										pImage->get_href(&bstrImage);
										CString strImage;
										strImage = bstrImage.m_str;
										stlImages.AddTail(strImage);
										continue;
									} // if
								} // else if
								else if ( !strTag.CompareNoCase("P") ) {
									// Paragraphs
									++iNumParagraphs;
								} // if
								else if ( !strTag.CompareNoCase("FONT") ) {
									// Fonts
									++iNumFonts;
								} // if
								else if ( !strTag.CompareNoCase("LI") ) {
									// List Item
									CComBSTR bstrText;
									pElement->get_innerText(&bstrText);
									if ( !bstrText ) {
										// Don't know...
										bstrText = _T("???");
									} // else

									// Insert into the correct list
									CString strText = bstrText.m_str;
									if ( bOrderedList ) {
										// Ordered list
										stlOList.AddTail(strText);
									} // if
									else {
										// Unordered list
										stlUList.AddTail(strText);
									} // else
								} // if
								else if ( !strTag.CompareNoCase("UL") ) {
									// Unordered list
									bOrderedList = FALSE;
									continue;
								} // if
								else if ( !strTag.CompareNoCase("OL") ) {
									// Ordered list
									bOrderedList = TRUE;
									continue;
								} // if
								else if ( !strTag.CompareNoCase("TABLE") ) {
									// Table definition
									++iNumTables;
									continue;
								} // if
								else if ( !strTag.CompareNoCase("TBODY") ) {
									// Table body (ignore)
									continue;
								} // if
								else if ( !strTag.CompareNoCase("TR") ) {
									// Table row (ignore)
									continue;
								} // if
								else if ( !strTag.CompareNoCase("TD") ) {
									// Table cell data
									CComBSTR bstrText;
									pElement->get_innerText(&bstrText);
									if ( !bstrText ) {
										// Don't know...
										bstrText = _T("???");
									} // else

									// Insert into list
									CString strText = bstrText.m_str;
									stlCells.AddTail(strText);
									continue;
								} // if
								else {
									// Generic tag, or one I didn't
									// snag otherwise
									stlGeneric.AddTail(strTag);
								} // else
							} // if
						} // if
					} // for
				} // if
			} // if
		} // if
		else {
			// We couldn't retrieve the IHTMLDocument2
			// interface.
			AfxMessageBox("Unable to retrieve the active document",
							MB_OK | MB_ICONERROR);
		} // else
	} // if

	// Now fill the tree control
	if ( !stlGeneric.IsEmpty() ) {
		// Pull the item text and insert into the tree
		for ( POSITION pos = stlGeneric.GetHeadPosition();
				pos != NULL; /*nothing*/ ) {
			// Snag this item
			CString strItem(stlGeneric.GetNext(pos));
			m_CDHTMLTree.InsertItem(strItem);
		} // for
	} // if

	if ( !m_strTitle.IsEmpty() ) {
		// Title
		CString strItem;
		strItem.Format("TITLE - \"%s\"",m_strTitle);
		m_CDHTMLTree.InsertItem(strItem);
	} // if

	if ( iNumParagraphs ) {
		// Insert paragraph marker
		CString strTag;
		strTag.Format("P (%d iterations)",iNumParagraphs);
		m_CDHTMLTree.InsertItem(strTag);
	} // if

	if ( iNumFonts ) {
		// Insert font marker
		CString strTag;
		strTag.Format("FONT (%d iterations)",iNumFonts);
		m_CDHTMLTree.InsertItem(strTag);
	} // if

	if ( !stlAnchors.IsEmpty() ) {
		HTREEITEM hRoot =
					m_CDHTMLTree.InsertItem(_T("Anchors"));

		// Pull the item text and insert into the tree
		for ( POSITION pos = stlAnchors.GetHeadPosition();
				pos != NULL; /*nothing*/ ) {
			// Snag this item
			CString strItem(stlAnchors.GetNext(pos));
			m_CDHTMLTree.InsertItem(strItem,hRoot);
		} // for
	} // if

	if ( !stlImages.IsEmpty() ) {
		HTREEITEM hRoot =
					m_CDHTMLTree.InsertItem(_T("Images"));

		// Pull the item text and insert into the tree
		for ( POSITION pos = stlImages.GetHeadPosition();
				pos != NULL; /*nothing*/ ) {
			// Snag this item
			CString strItem(stlImages.GetNext(pos));
			m_CDHTMLTree.InsertItem(strItem,hRoot);
		} // for
	} // if

	if ( !stlOList.IsEmpty() ) {
		HTREEITEM hRoot =
					m_CDHTMLTree.InsertItem(_T("Ordered list items"));

		// Pull the item text and insert into the tree
		for ( POSITION pos = stlOList.GetHeadPosition();
				pos != NULL; /*nothing*/ ) {
			// Snag this item
			CString strItem(stlOList.GetNext(pos));
			m_CDHTMLTree.InsertItem(strItem,hRoot);
		} // for
	} // if

	if ( !stlUList.IsEmpty() ) {
		HTREEITEM hRoot =
					m_CDHTMLTree.InsertItem(_T("Unordered list items"));

		// Pull the item text and insert into the tree
		for ( POSITION pos = stlUList.GetHeadPosition();
				pos != NULL; /*nothing*/ ) {
			// Snag this item
			CString strItem(stlUList.GetNext(pos));
			m_CDHTMLTree.InsertItem(strItem,hRoot);
		} // for
	} // if

	if ( iNumTables ) {
		CString strTag;
		strTag.Format("Tables (%d iterations)",iNumTables);
		HTREEITEM hRoot =
					m_CDHTMLTree.InsertItem(strTag);

		// Pull the item text and insert into the tree
		for ( POSITION pos = stlCells.GetHeadPosition();
				pos != NULL; /*nothing*/ ) {
			// Snag this item
			CString strItem(stlCells.GetNext(pos));
			m_CDHTMLTree.InsertItem(strItem,hRoot);
		} // for
	} // if
}
