// WebDlgBox.cpp : implementation file
//

#include "stdafx.h"
#include "WebDlg.h"
#include "WebDlgBox.h"

// DHTML definitions
#include "MSHTML.H"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWebDlg dialog

CWebDlg::CWebDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWebDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWebDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CWebDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWebDlg)
	DDX_Control(pDX, IDC_URL, m_CURLBox);
	DDX_Control(pDX, IDC_DHTMLTREE, m_CDHTMLTree);
	DDX_Control(pDX, IDC_EXPLORER, m_CExplorer);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWebDlg, CDialog)
	//{{AFX_MSG_MAP(CWebDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_LOAD, OnLoad)
	ON_BN_CLICKED(IDC_FORWARD, OnForward)
	ON_BN_CLICKED(IDC_BACK, OnBack)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWebDlg message handlers

BOOL CWebDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// Load an initial HTML page from this app's
	// resources.
	CWebDlgApp* pApp = (CWebDlgApp*)AfxGetApp();
	char szPath[MAX_PATH+1] = {0};
	GetModuleFileName(pApp->m_hInstance,szPath,MAX_PATH);

	CString strUrl(_T("res://")); // "res" protocol
	strUrl = strUrl + szPath; // app file path
	strUrl = strUrl + _T("/Default.htm"); // resource string...
	m_CExplorer.Navigate(strUrl,NULL,NULL,NULL,NULL);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CWebDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CWebDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CWebDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CWebDlg::OnLoad() 
{
	// Navigate to URL in combobox
	CString strURL;
	m_CURLBox.GetWindowText(strURL);
	m_CExplorer.Navigate(strURL,NULL,NULL,NULL,NULL);
}

void CWebDlg::OnForward() 
{
	// Go forward in history
	try {
		m_CExplorer.GoForward();
	} // try
	catch (...) {
		// An exception, most likely COleDispatchException
		// from a lack of forward references in the
		// browser's cache.  Not a problem, just put up
		// a message box...
		AfxMessageBox("Unable to navigate forward in cache.",
						MB_OK | MB_ICONERROR);
	} // catch
}

void CWebDlg::OnBack() 
{
	// Go back in history
	try {
		m_CExplorer.GoBack();
	} // try
	catch (...) {
		// An exception, most likely COleDispatchException
		// from a lack of reverse references in the
		// browser's cache.  Not a problem, just put up
		// a message box...
		AfxMessageBox("Unable to navigate backwards in cache.",
						MB_OK | MB_ICONERROR);
	} // catch
}

void CWebDlg::OnBrowse() 
{
	// File filter
	static TCHAR BASED_CODE szHTMLFilter[] = _T("HTM Files (*.htm)|*.htm|HTML Files (*.html)|*.html|All Files (*.*)|*.*||");	

	// Bring up a file dialog to browse for HTML files.
	CFileDialog dlgHTML(TRUE,
					_T("htm"),
					NULL,
					OFN_EXPLORER,
					szHTMLFilter,
					this);

	dlgHTML.m_ofn.lpstrTitle = _T("Navigate to HTML file");

	if ( dlgHTML.DoModal() != IDOK ) {
		// User canceled...
		return;
	} // if

	// Pull file location and insert into the
	// URL combobox.
	CString strURL(_T("file://"));
	strURL += dlgHTML.GetPathName();
	m_CURLBox.AddString(strURL);
	m_CURLBox.SetWindowText(strURL);

	// Load it automatically
	OnLoad();
}

BEGIN_EVENTSINK_MAP(CWebDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CWebDlg)
	ON_EVENT(CWebDlg, IDC_EXPLORER, 259 /* DocumentComplete */, OnDocumentComplete, VTS_DISPATCH VTS_PVARIANT)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

// NOTE: This is where almost ALL of the DHTML magic
// happens. 
void CWebDlg::OnDocumentComplete(LPDISPATCH pDisp, VARIANT FAR* URL) 
{
	// Clear the tree control
	m_CDHTMLTree.DeleteAllItems();

	// Declare lists
	CStringList stlGeneric;
	CStringList stlImages;
	CStringList stlAnchors;
	CStringList stlUList;
	CStringList stlOList;
	CStringList stlCells;
	CString strTitle;
	int iNumParagraphs = 0;
	int iNumFonts = 0;
	int iNumTables = 0;
	BOOL bOrderedList = TRUE;

	// Retrieve the active document
	CComPtr<IDispatch> pDocDispatch = m_CExplorer.GetDocument();

	// Check to see that we do have a document.  The
	// HTML document pointer will be NULL if the
	// browser was unable to load the HTML file.
	if ( pDocDispatch.p != NULL ) {
		// We have a document, so now query for the
		// IHTMLDocument2 interface
		CComQIPtr<IHTMLDocument2,&IID_IHTMLDocument2> pHTMLDocument2(pDocDispatch);
		if ( pHTMLDocument2.p != NULL ) {
			// We have an active document, so retrieve the
			// anchor element collection.
			CComPtr<IHTMLElementCollection> pElements;
			HRESULT hr = pHTMLDocument2->get_all(&pElements);
			if ( SUCCEEDED(hr) ) {
				// Pull the elements and insert into the string
				// list.
				long iNumElements;
				hr = pElements->get_length(&iNumElements);
				if ( SUCCEEDED(hr) && iNumElements ) {

					// Loop through the number of items
					// and pull its IHTMLElement interface
					// pointer.
					for ( long i = 0; i < iNumElements; i++ ) {
						CComVariant varName(i);
						varName.ChangeType(VT_UINT);
						CComVariant varIndex;
						CComPtr<IDispatch> pDisp; 

						// Retrieve item in collection
						hr = pElements->item(varName,varIndex,&pDisp);
						if ( SUCCEEDED(hr) ) {
							// We have the element, so retrieve its
							// tag name.
							CComQIPtr<IHTMLElement,
								&IID_IHTMLElement> pElement(pDisp);
							if ( pElement != NULL ) {
								// Pull the tag string
								CString strTag;
								CComBSTR bstrTag;
								hr = pElement->get_tagName(&bstrTag);
								if ( !bstrTag ) {
									strTag = _T("???");
								} // if
								else {
									strTag = bstrTag.m_str;
								} // if

								// Determine the tag and pull
								// additional info depending...
								if ( !strTag.CompareNoCase("A") ) {
									// Anchor
									CComBSTR bstrAnchor;
									CComQIPtr<IHTMLAnchorElement,
										&IID_IHTMLAnchorElement> pAnchor(pDisp);
									if ( pAnchor ) {
										// Was a link...
										pAnchor->get_href(&bstrAnchor);
										if ( !bstrAnchor ) {
											// Could be a name instead
											// of a link...
											pAnchor->get_name(&bstrAnchor);
										} // if
										if ( !bstrAnchor ) {
											// Now I have no idea!
											bstrAnchor = _T("???");
										} // if
										CString strAnchor;
										strAnchor = bstrAnchor.m_str;
										stlAnchors.AddTail(strAnchor);
										continue;
									} // if
								} // if
								else if ( !strTag.CompareNoCase("TITLE") ) {
									// Title
									CComBSTR bstrText;
									CComQIPtr<IHTMLTitleElement,
										&IID_IHTMLTitleElement> pTitle(pDisp);
									if ( pTitle ) {
										pTitle->get_text(&bstrText);
										if ( !bstrText ) {
											// Don't know...
											bstrText = _T("???");
										} // if
									} // if

									// Insert into string
									strTitle = bstrText.m_str;
								} // else if
								else if ( !strTag.CompareNoCase("IMG") ) {
									// Try an image
									CComQIPtr<IHTMLImgElement,
										&IID_IHTMLImgElement> pImage(pDisp);
									if ( pImage ) {
										// Was a image...
										CComBSTR bstrImage;
										pImage->get_href(&bstrImage);
										CString strImage;
										strImage = bstrImage.m_str;
										stlImages.AddTail(strImage);
										continue;
									} // if
								} // else if
								else if ( !strTag.CompareNoCase("P") ) {
									// Paragraphs
									++iNumParagraphs;
								} // if
								else if ( !strTag.CompareNoCase("FONT") ) {
									// Fonts
									++iNumFonts;
								} // if
								else if ( !strTag.CompareNoCase("LI") ) {
									// List Item
									CComBSTR bstrText;
									pElement->get_innerText(&bstrText);
									if ( !bstrText ) {
										// Don't know...
										bstrText = _T("???");
									} // else

									// Insert into the correct list
									CString strText = bstrText.m_str;
									if ( bOrderedList ) {
										// Ordered list
										stlOList.AddTail(strText);
									} // if
									else {
										// Unordered list
										stlUList.AddTail(strText);
									} // else
								} // if
								else if ( !strTag.CompareNoCase("UL") ) {
									// Unordered list
									bOrderedList = FALSE;
									continue;
								} // if
								else if ( !strTag.CompareNoCase("OL") ) {
									// Ordered list
									bOrderedList = TRUE;
									continue;
								} // if
								else if ( !strTag.CompareNoCase("TABLE") ) {
									// Table definition
									++iNumTables;
									continue;
								} // if
								else if ( !strTag.CompareNoCase("TBODY") ) {
									// Table body (ignore)
									continue;
								} // if
								else if ( !strTag.CompareNoCase("TR") ) {
									// Table row (ignore)
									continue;
								} // if
								else if ( !strTag.CompareNoCase("TD") ) {
									// Table cell data
									CComBSTR bstrText;
									pElement->get_innerText(&bstrText);
									if ( !bstrText ) {
										// Don't know...
										bstrText = _T("???");
									} // else

									// Insert into list
									CString strText = bstrText.m_str;
									stlCells.AddTail(strText);
									continue;
								} // if
								else {
									// Generic tag, or one I didn't
									// snag otherwise
									stlGeneric.AddTail(strTag);
								} // else
							} // if
						} // if
					} // for
				} // if
			} // if
		} // if
		else {
			// We couldn't retrieve the IHTMLDocument2
			// interface.
			AfxMessageBox("Unable to retrieve the active document",
							MB_OK | MB_ICONERROR);
		} // else
	} // if

	// Now fill the tree control
	if ( !stlGeneric.IsEmpty() ) {
		// Pull the item text and insert into the tree
		for ( POSITION pos = stlGeneric.GetHeadPosition();
				pos != NULL; /*nothing*/ ) {
			// Snag this item
			CString strItem(stlGeneric.GetNext(pos));
			m_CDHTMLTree.InsertItem(strItem);
		} // for
	} // if

	if ( !strTitle.IsEmpty() ) {
		// Title
		CString strItem;
		strItem.Format("TITLE - \"%s\"",strTitle);
		m_CDHTMLTree.InsertItem(strItem);
	} // if

	if ( iNumParagraphs ) {
		// Insert paragraph marker
		CString strTag;
		strTag.Format("P (%d iterations)",iNumParagraphs);
		m_CDHTMLTree.InsertItem(strTag);
	} // if

	if ( iNumFonts ) {
		// Insert font marker
		CString strTag;
		strTag.Format("FONT (%d iterations)",iNumFonts);
		m_CDHTMLTree.InsertItem(strTag);
	} // if

	if ( !stlAnchors.IsEmpty() ) {
		HTREEITEM hRoot =
					m_CDHTMLTree.InsertItem(_T("Anchors"));

		// Pull the item text and insert into the tree
		for ( POSITION pos = stlAnchors.GetHeadPosition();
				pos != NULL; /*nothing*/ ) {
			// Snag this item
			CString strItem(stlAnchors.GetNext(pos));
			m_CDHTMLTree.InsertItem(strItem,hRoot);
		} // for
	} // if

	if ( !stlImages.IsEmpty() ) {
		HTREEITEM hRoot =
					m_CDHTMLTree.InsertItem(_T("Images"));

		// Pull the item text and insert into the tree
		for ( POSITION pos = stlImages.GetHeadPosition();
				pos != NULL; /*nothing*/ ) {
			// Snag this item
			CString strItem(stlImages.GetNext(pos));
			m_CDHTMLTree.InsertItem(strItem,hRoot);
		} // for
	} // if

	if ( !stlOList.IsEmpty() ) {
		HTREEITEM hRoot =
					m_CDHTMLTree.InsertItem(_T("Ordered list items"));

		// Pull the item text and insert into the tree
		for ( POSITION pos = stlOList.GetHeadPosition();
				pos != NULL; /*nothing*/ ) {
			// Snag this item
			CString strItem(stlOList.GetNext(pos));
			m_CDHTMLTree.InsertItem(strItem,hRoot);
		} // for
	} // if

	if ( !stlUList.IsEmpty() ) {
		HTREEITEM hRoot =
					m_CDHTMLTree.InsertItem(_T("Unordered list items"));

		// Pull the item text and insert into the tree
		for ( POSITION pos = stlUList.GetHeadPosition();
				pos != NULL; /*nothing*/ ) {
			// Snag this item
			CString strItem(stlUList.GetNext(pos));
			m_CDHTMLTree.InsertItem(strItem,hRoot);
		} // for
	} // if

	if ( iNumTables ) {
		CString strTag;
		strTag.Format("Tables (%d iterations)",iNumTables);
		HTREEITEM hRoot =
					m_CDHTMLTree.InsertItem(strTag);

		// Pull the item text and insert into the tree
		for ( POSITION pos = stlCells.GetHeadPosition();
				pos != NULL; /*nothing*/ ) {
			// Snag this item
			CString strItem(stlCells.GetNext(pos));
			m_CDHTMLTree.InsertItem(strItem,hRoot);
		} // for
	} // if
}