//-----------------------------------------------------------------
// Investment Wizard Object
// C++ Source - InvestmentWiz.cpp
//-----------------------------------------------------------------

//-----------------------------------------------------------------
// Inclusions
//-----------------------------------------------------------------
#include "StdAfx.h"
//-----------------------------------------------------------------
#include "InvestmentWiz.h"

//-----------------------------------------------------------------
// MFC Debugging Support
//-----------------------------------------------------------------
#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif


//-----------------------------------------------------------------
// Global Variables
//-----------------------------------------------------------------
CInvestmentWiz* pInvestmentWiz;
CInvestWizData  wizData;

//-----------------------------------------------------------------
// CInvestWizData Public Constructor(s)/Destructor
//-----------------------------------------------------------------
CInvestWizData::CInvestWizData() {
  // Initialize the wizard data
  m_sFName = "John";
  m_sMInitial = "D";
  m_sLName = "Doe";
  m_fAmount = 1000.0;
  m_fReturnRate = 8.0;
  m_nPeriod = 10;
}

//-----------------------------------------------------------------
// CInvestWizPage1 Message Map & Runtime Support
//-----------------------------------------------------------------
BEGIN_MESSAGE_MAP(CInvestWizPage1, CPropertyPage)
  ON_WM_PAINT()
END_MESSAGE_MAP()

//-----------------------------------------------------------------
// CInvestWizPage1 Public Member Functions
//-----------------------------------------------------------------
BOOL CInvestWizPage1::OnInitDialog() {
  // Load the bitmap
  m_bitmap.LoadBitmap(IDB_INVESTWIZPAGE1);

  return TRUE;
}

BOOL CInvestWizPage1::OnSetActive() {
  // Show only the Next button
  pInvestmentWiz->SetWizardButtons(PSWIZB_NEXT);

  // Set the control values
  SetDlgItemText(IDC_FNAME, wizData.m_sFName);
  SetDlgItemText(IDC_MINITIAL, wizData.m_sMInitial);
  SetDlgItemText(IDC_LNAME, wizData.m_sLName);

  return TRUE;
}

void CInvestWizPage1::DoDataExchange(CDataExchange* pDX) {
  CDialog::DoDataExchange(pDX);

  // Exchange the dialog data
  DDX_Text(pDX, IDC_FNAME, wizData.m_sFName);
  DDX_Text(pDX, IDC_MINITIAL, wizData.m_sMInitial);
  DDX_Text(pDX, IDC_LNAME, wizData.m_sLName);
}

//-----------------------------------------------------------------
// CInvestWizPage1 Message Handlers
//-----------------------------------------------------------------
void CInvestWizPage1::OnPaint() {
  CPaintDC dc(this);

  // Select the bitmap into a memory DC
  CDC dcMem;
  dcMem.CreateCompatibleDC(&dc);
  dcMem.SelectObject(&m_bitmap);

  // Copy the bitmap to the dialog DC
  dc.BitBlt(0, 0, 129, 226, &dcMem, 0, 0, SRCCOPY);
}

//-----------------------------------------------------------------
// CInvestWizPage2 Message Map & Runtime Support
//-----------------------------------------------------------------
BEGIN_MESSAGE_MAP(CInvestWizPage2, CPropertyPage)
  ON_WM_PAINT()
END_MESSAGE_MAP()

//-----------------------------------------------------------------
// CInvestWizPage2 Public Member Functions
//-----------------------------------------------------------------
BOOL CInvestWizPage2::OnInitDialog() {
  // Load the bitmap
  m_bitmap.LoadBitmap(IDB_INVESTWIZPAGE2);

  return TRUE;
}

BOOL CInvestWizPage2::OnSetActive() {
  // Show the Back and Next buttons
  pInvestmentWiz->SetWizardButtons(PSWIZB_BACK | PSWIZB_NEXT);
  
  // Set the control values
  CString sVal;
  sVal.Format("%.2f", wizData.m_fAmount);
  SetDlgItemText(IDC_AMOUNT, sVal);
  sVal.Format("%.2f", wizData.m_fReturnRate);
  SetDlgItemText(IDC_RETURNRATE, sVal);
  sVal.Format("%d", wizData.m_nPeriod);
  SetDlgItemText(IDC_PERIOD, sVal);

  return TRUE;
}

void CInvestWizPage2::DoDataExchange(CDataExchange* pDX) {
  CDialog::DoDataExchange(pDX);

  // Exchange the dialog data
  DDX_Text(pDX, IDC_AMOUNT, wizData.m_fAmount);
  DDX_Text(pDX, IDC_RETURNRATE, wizData.m_fReturnRate);
  DDX_Text(pDX, IDC_PERIOD, wizData.m_nPeriod);
}

//-----------------------------------------------------------------
// CInvestWizPage2 Message Handlers
//-----------------------------------------------------------------
void CInvestWizPage2::OnPaint() {
  CPaintDC dc(this);

  // Select the bitmap into a memory DC
  CDC dcMem;
  dcMem.CreateCompatibleDC(&dc);
  dcMem.SelectObject(&m_bitmap);

  // Copy the bitmap to the dialog DC
  dc.BitBlt(0, 0, 129, 226, &dcMem, 0, 0, SRCCOPY);
}

//-----------------------------------------------------------------
// CInvestWizPage3 Message Map & Runtime Support
//-----------------------------------------------------------------
BEGIN_MESSAGE_MAP(CInvestWizPage3, CPropertyPage)
  ON_WM_PAINT()
END_MESSAGE_MAP()

//-----------------------------------------------------------------
// CInvestWizPage3 Public Member Functions
//-----------------------------------------------------------------
BOOL CInvestWizPage3::OnInitDialog() {
  // Load the bitmap
  m_bitmap.LoadBitmap(IDB_INVESTWIZPAGE3);

  return TRUE;
}

BOOL CInvestWizPage3::OnSetActive() {
  // Show the Back and Finish buttons
  pInvestmentWiz->SetWizardButtons(PSWIZB_BACK | PSWIZB_FINISH);

  // Calculate the investment
  float fTotal = wizData.m_fAmount;
  for (int i = 0; i < wizData.m_nPeriod; i++)
    fTotal += (fTotal * (wizData.m_fReturnRate / 100));

  // Display the result
  CString sResult;
  sResult.Format("%s %s. %s's total investment after %d years is $%.2f.",
    wizData.m_sFName, wizData.m_sMInitial, wizData.m_sLName,
    wizData.m_nPeriod, fTotal);
  SetDlgItemText(IDC_RESULT, sResult);

  return TRUE;
}

//-----------------------------------------------------------------
// CInvestWizPage3 Message Handlers
//-----------------------------------------------------------------
void CInvestWizPage3::OnPaint() {
  CPaintDC dc(this);

  // Select the bitmap into a memory DC
  CDC dcMem;
  dcMem.CreateCompatibleDC(&dc);
  dcMem.SelectObject(&m_bitmap);

  // Copy the bitmap to the dialog DC
  dc.BitBlt(0, 0, 129, 226, &dcMem, 0, 0, SRCCOPY);
}

//-----------------------------------------------------------------
// CInvestmentWiz Message Map & Runtime Support
//-----------------------------------------------------------------
BEGIN_MESSAGE_MAP(CInvestmentWiz, CPropertySheet)
END_MESSAGE_MAP()

//-----------------------------------------------------------------
// CInvestmentWiz Public Constructor(s)/Destructor
//-----------------------------------------------------------------
CInvestmentWiz::CInvestmentWiz() : CPropertySheet() {
  // Create the investment wizard
  Construct("Investment Wizard", this);

  // Add the wizard pages
  m_page1.Construct(IDD_INVESTWIZPAGE1, 0);
  m_page2.Construct(IDD_INVESTWIZPAGE2, 0);
  m_page3.Construct(IDD_INVESTWIZPAGE3, 0);
  AddPage(&m_page1);
  AddPage(&m_page2);
  AddPage(&m_page3);

  // Set the wizard global variable for page access
  pInvestmentWiz = this;
}
