//-----------------------------------------------------------------
// Shape Object
// C++ Header - Shape.h
//-----------------------------------------------------------------

#ifndef __SHAPE_H__
#define __SHAPE_H__

//-----------------------------------------------------------------
// CShape Class - Shape Object
//-----------------------------------------------------------------
class CShape : public CObject {
  // Public Member Constants
public:
  enum  { LINE, RECTANGLE, TRIANGLE, ELLIPSE };

  // Member Variables
private:
  int       m_nType;
  CRect     m_rcPosition;
  COLORREF  m_crColor;

  // Constructor(s)/Destructor
protected:
  CShape(); // for serialization only
public:
  CShape(int nType, CRect& rcPosition, COLORREF crColor);

  // Public Member Functions
public:
  void          Draw(CDC* pDC);
  virtual void  Serialize(CArchive& ar);
  CRect&        GetPosition() { return m_rcPosition; }
  CString       GetTypeAsString();

  // Serialization Support
protected:
  DECLARE_SERIAL(CShape)
};

#endif
