//-----------------------------------------------------------------
// Shaper Application Object
// C++ Source - Shaper.cpp
//-----------------------------------------------------------------

//-----------------------------------------------------------------
// Inclusions
//-----------------------------------------------------------------
#include "StdAfx.h"
//-----------------------------------------------------------------
#include "Shaper.h"
#include "MainFrame.h"
#include "ShaperDoc.h"
#include "ShaperView.h"

//-----------------------------------------------------------------
// MFC Debugging Support
//-----------------------------------------------------------------
#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

//-----------------------------------------------------------------
// Global Variables
//-----------------------------------------------------------------
CShaperApp theApp;


//-----------------------------------------------------------------
// Message Map & Runtime Support
//-----------------------------------------------------------------
BEGIN_MESSAGE_MAP(CShaperApp, CWinApp)
  ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
  ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
  ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

//-----------------------------------------------------------------
// Public Constructor(s)/Destructor
//-----------------------------------------------------------------
CShaperApp::CShaperApp() {
}

CShaperApp::~CShaperApp() {
}

//-----------------------------------------------------------------
// Public Member Functions
//-----------------------------------------------------------------
BOOL CShaperApp::InitInstance() {
  // Load INI file options and MRU list
  LoadStdProfileSettings();

  // Register the application's document templates
  CSingleDocTemplate* pDocTemplate;
  pDocTemplate = new CSingleDocTemplate(IDR_SHAPER,
    RUNTIME_CLASS(CShaperDoc),
    RUNTIME_CLASS(CMainFrame),
    RUNTIME_CLASS(CShaperView));
  AddDocTemplate(pDocTemplate);

  // Parse command line for standard shell commands
  CCommandLineInfo cmdInfo;
  ParseCommandLine(cmdInfo);

  // Dispatch commands specified on the command line
  if (!ProcessShellCommand(cmdInfo))
    return FALSE;

  // Show and update the main window
  m_pMainWnd->ShowWindow(SW_SHOW);
  m_pMainWnd->UpdateWindow();

  return TRUE;
}
