//-----------------------------------------------------------------
// Shaper Document Object
// C++ Header - ShaperDoc.h
//-----------------------------------------------------------------

#ifndef __SHAPERDOC_H__
#define __SHAPERDOC_H__

//-----------------------------------------------------------------
// Inclusions
//-----------------------------------------------------------------
#include "Shape.h"

//-----------------------------------------------------------------
// CShaperDoc Class - Shaper Document Object
//-----------------------------------------------------------------
class CShaperDoc : public CDocument {
  // Member Variables
protected:
  CSize m_sizDoc;
public:
  CTypedPtrList <CObList, CShape*>  m_shapeList;

  // Public Constructor(s)/Destructor
public:
                CShaperDoc();
  virtual       ~CShaperDoc();

  // Public Member Functions
public:
  virtual BOOL  OnNewDocument();
  virtual BOOL  OnOpenDocument(LPCTSTR lpszPathName);
  virtual void  DeleteContents();
  virtual void  Serialize(CArchive& ar);
  void          AddShape(CShape* pShape);
  CSize&        GetDocSize() { return m_sizDoc; }

  // Message Handlers
public:
  afx_msg void  OnEditClearAll();
  afx_msg void  OnUpdateEditClearAll(CCmdUI* pCmdUI);

  // Diagnostic Functions
public:
#ifdef _DEBUG
  virtual void  AssertValid() const;
  virtual void  Dump(CDumpContext& dc) const;
#endif //_DEBUG

  // Message Map & Runtime Support
protected:
  DECLARE_MESSAGE_MAP()
  DECLARE_DYNCREATE(CShaperDoc)
};

#endif
