//-----------------------------------------------------------------
// Shaper View Object
// C++ Header - ShaperView.h
//-----------------------------------------------------------------

#ifndef __SHAPERVIEW_H__
#define __SHAPERVIEW_H__

//-----------------------------------------------------------------
// CShaperView Class - Shaper View Object
//-----------------------------------------------------------------
class CShaperView : public CScrollView {
  // Member Variables
protected:
  int       m_nDrawMode;
  COLORREF  m_crColor;

  // Public Constructor(s)/Destructor
public:
                CShaperView();
  virtual       ~CShaperView();

  // Public Member Functions
public:
  virtual void  OnDraw(CDC* pDC);
  virtual void  OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
  virtual void  OnInitialUpdate();
  virtual void  OnPrint(CDC* pDC, CPrintInfo* pInfo);
  CShaperDoc*   GetDocument();

  // Protected Member Functions
protected:
  virtual BOOL  OnPreparePrinting(CPrintInfo* pInfo);
  void          PrintPageHeader(CDC* pDC, CPrintInfo* pInfo, CString& sHeader);

  // Message Handlers
public:
  afx_msg void  OnLButtonDown(UINT nFlags, CPoint point);
  afx_msg void  OnDrawLine();
  afx_msg void  OnDrawRectangle();
  afx_msg void  OnDrawTriangle();
  afx_msg void  OnDrawEllipse();
  afx_msg void  OnDrawChangeColor();
  afx_msg void  OnUpdateDrawLine(CCmdUI* pCmdUI);
  afx_msg void  OnUpdateDrawRectangle(CCmdUI* pCmdUI);
  afx_msg void  OnUpdateDrawTriangle(CCmdUI* pCmdUI);
  afx_msg void  OnUpdateDrawEllipse(CCmdUI* pCmdUI);

  // Diagnostic Functions
public:
#ifdef _DEBUG
  virtual void  AssertValid() const;
  virtual void  Dump(CDumpContext& dc) const;
#endif //_DEBUG

  // Message Map & Runtime Support
protected:
  DECLARE_MESSAGE_MAP()
  DECLARE_DYNCREATE(CShaperView)
};

#ifndef _DEBUG
inline CShaperDoc* CShaperView::GetDocument() {
  return (CShaperDoc*)m_pDocument;
}
#endif //_DEBUG

#endif
