///////////////////////////////////////////////////////////////////
// Header   : TAB1.H
//
// Purpose  : Header for the TAB1 program.
//
// Author   : Rob McGregor, rob_mcgregor@compuserve.com
//        
// Date     : 06-15-96
///////////////////////////////////////////////////////////////////

#include "stdafx.h" 

#define WS_VISCHILD (WS_VISIBLE | WS_CHILD)

///////////////////////////////////////////////////////////////////
// Derive an application class 

class CTestApp : public CWinApp
{ 
public: 
   virtual BOOL InitInstance(); 
};

///////////////////////////////////////////////////////////////////
// Derive a frame window class

#define IDC_TABCTRL      125
#define IDC_ANIMCTRL     126
#define IDC_RICHEDITCTRL 127
#define IDC_PROGRESSCTRL 128

class CMainWnd : public CFrameWnd
{
public:
   CMainWnd();
   virtual ~CMainWnd();
   
   void DoTabAnimate();
   void DoTabRichText();
   void DoTabProgress();
   void SetClientBackColor(LONG lColor);
   void SetStyleHeading1(CHARFORMAT& cf);
   void SetStyleHeading2(CHARFORMAT& cf);
   void SetStyleNormal(CHARFORMAT& cf);
   void Wait(long lTime);

protected:
   CTabCtrl       m_ctlTab;
   CAnimateCtrl   m_ctlAnim;
   CRichEditCtrl  m_ctlRichEdit;
   CProgressCtrl  m_ctlProgress;
 
   void GenerateRichText();

   // Message handlers
   afx_msg int OnCreate(LPCREATESTRUCT lpcs);
   afx_msg void OnClickTabCtrl(NMHDR* pNotifyStruct, 
      LRESULT* pResult);
   afx_msg void OnSize(UINT nType, int cx, int cy);

   DECLARE_MESSAGE_MAP();
};

//////////////////////////////////////////////////////////////////