// ATLActiveXCtl.cpp : Implementation of CATLActiveXCtl

#include "stdafx.h"
#include "ATLActiveX.h"
#include "ATLActiveXCtl.h"

/////////////////////////////////////////////////////////////////////////////
// CATLActiveXCtl


STDMETHODIMP CATLActiveXCtl::SetAntenna(short nAntenna)
{
	// the antenna selection identifies the supported data rate 
	m_nAntenna = nAntenna;
	switch(nAntenna) 
	{
	case 1:
		m_nDataRate = 100;
		break;
	case 2:
		m_nDataRate = 10;
		break;
	default:
		m_nDataRate = 5;
		break;
	}

	FireViewChange();

	return S_OK;
}

STDMETHODIMP CATLActiveXCtl::get_BufferSize(short *pVal)
{
	pVal = &m_bufferSize;

	return S_OK;
}

STDMETHODIMP CATLActiveXCtl::put_BufferSize(short newVal)
{
	m_bufferSize = newVal;

	return S_OK;
}

STDMETHODIMP CATLActiveXCtl::get_AcquireData(BOOL *pVal)
{
	pVal = &m_acquireData;

	return S_OK;
}

STDMETHODIMP CATLActiveXCtl::put_AcquireData(BOOL newVal)
{
	m_acquireData = newVal;
	if (newVal) 
	{
		SetTimer(3442, (1000/m_nDataRate)*500);
	}
	else 
	{
		KillTimer(3442);
	}
	FireViewChange();

	return S_OK;
}

