// ATLActiveXCtl.h : Declaration of the CATLActiveXCtl

#ifndef __ATLACTIVEXCTL_H_
#define __ATLACTIVEXCTL_H_

#include "resource.h"       // main symbols
#include <atlctl.h>
#include "ATLActiveXCP.h"


/////////////////////////////////////////////////////////////////////////////
// CATLActiveXCtl
class ATL_NO_VTABLE CATLActiveXCtl : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public IDispatchImpl<IATLActiveXCtl, &IID_IATLActiveXCtl, &LIBID_ATLACTIVEXLib>,
	public CComControl<CATLActiveXCtl>,
	public IPersistStreamInitImpl<CATLActiveXCtl>,
	public IOleControlImpl<CATLActiveXCtl>,
	public IOleObjectImpl<CATLActiveXCtl>,
	public IOleInPlaceActiveObjectImpl<CATLActiveXCtl>,
	public IViewObjectExImpl<CATLActiveXCtl>,
	public IOleInPlaceObjectWindowlessImpl<CATLActiveXCtl>,
	public IConnectionPointContainerImpl<CATLActiveXCtl>,
	public IPersistStorageImpl<CATLActiveXCtl>,
	public ISpecifyPropertyPagesImpl<CATLActiveXCtl>,
	public IQuickActivateImpl<CATLActiveXCtl>,
	public IDataObjectImpl<CATLActiveXCtl>,
	public IProvideClassInfo2Impl<&CLSID_ATLActiveXCtl, &DIID__IATLActiveXCtlEvents, &LIBID_ATLACTIVEXLib>,
	public IPropertyNotifySinkCP<CATLActiveXCtl>,
	public CComCoClass<CATLActiveXCtl, &CLSID_ATLActiveXCtl>,
	public CProxy_IATLActiveXCtlEvents< CATLActiveXCtl >
{
public:
	CATLActiveXCtl()
	{
		// Initialize your control's instance data here.
		m_nDataRate = 100;
		m_nAntenna = 1;
		m_nDataCount = 0;
		m_bufferSize = 5;
		m_nThermal = 3;
		m_acquireData = false;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_ATLACTIVEXCTL)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CATLActiveXCtl)
	COM_INTERFACE_ENTRY(IATLActiveXCtl)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStorage)
	COM_INTERFACE_ENTRY(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
	COM_INTERFACE_ENTRY_IMPL(IConnectionPointContainer)
END_COM_MAP()

BEGIN_PROP_MAP(CATLActiveXCtl)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()

BEGIN_CONNECTION_POINT_MAP(CATLActiveXCtl)
	CONNECTION_POINT_ENTRY(IID_IPropertyNotifySink)
	CONNECTION_POINT_ENTRY(DIID__IATLActiveXCtlEvents)
END_CONNECTION_POINT_MAP()

BEGIN_MSG_MAP(CATLActiveXCtl)
	CHAIN_MSG_MAP(CComControl<CATLActiveXCtl>)
	DEFAULT_REFLECTION_HANDLER()
	MESSAGE_HANDLER(WM_TIMER, OnTimer)
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);



// IViewObjectEx
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)

// IATLActiveXCtl
public:
	STDMETHOD(get_AcquireData)(/*[out, retval]*/ BOOL *pVal);
	STDMETHOD(put_AcquireData)(/*[in]*/ BOOL newVal);
	STDMETHOD(get_BufferSize)(/*[out, retval]*/ short *pVal);
	STDMETHOD(put_BufferSize)(/*[in]*/ short newVal);
	STDMETHOD(SetAntenna)(/*[in]*/ short nAntenna);

	HRESULT OnDraw(ATL_DRAWINFO& di)
	{
		HBRUSH hb = NULL;
		RECT& rcBounds = *(RECT*)di.prcBounds;
		// the background of the control represents the thermal indication
		switch (m_nThermal) 
		{
		case 1:
			FillRect(di.hdcDraw, &rcBounds, (hb = (HBRUSH)::CreateSolidBrush(COLORREF(0x000000ff))));
			break;
		case 2:
			FillRect(di.hdcDraw, &rcBounds, (hb = (HBRUSH)::CreateSolidBrush(COLORREF(0x0000ffff))));
			break;
		case 3:
			FillRect(di.hdcDraw, &rcBounds, (hb = (HBRUSH)::CreateSolidBrush(COLORREF(0x0000ff00))));
			break;
		}
		::DeleteObject(hb);

		// provide a white area for the indicators
		RECT rcEmpty(rcBounds);
		rcEmpty.top += 9;
		rcEmpty.bottom = rcEmpty.top+15;
		rcEmpty.left += 9;
		rcEmpty.right = 92;
		FillRect(di.hdcDraw, &rcEmpty, (hb = (HBRUSH)::CreateSolidBrush(COLORREF(0x000ffffff))));
		rcEmpty = rcBounds;
		rcEmpty.top = +39;
		rcEmpty.bottom = rcEmpty.top+15;
		rcEmpty.left += 9;
		rcEmpty.right = 136;
		FillRect(di.hdcDraw, &rcEmpty, hb); 
		::DeleteObject(hb);

		// indicator labels
		SelectObject(di.hdcDraw, ::GetStockObject(ANSI_VAR_FONT));
		TextOut(di.hdcDraw, rcBounds.left+10, rcBounds.top+10,"Power", 5);
		TextOut(di.hdcDraw, rcBounds.left+10, rcBounds.top+30,"Antenna", 7);
		// draw power indicator
		RECT rcPower(rcBounds);
		rcPower.top += 12;
		rcPower.bottom = rcPower.top + 10;
		rcPower.left = 70;
		rcPower.right = rcPower.left + 10;
		if (m_acquireData)
			FillRect(di.hdcDraw, &rcPower, (hb = (HBRUSH)::CreateSolidBrush(COLORREF(0x0000ff00))));
		else
			FillRect(di.hdcDraw, &rcPower, (hb = (HBRUSH)::CreateSolidBrush(COLORREF(0x000000ff))));
		::DeleteObject(hb);

		// draw antenna indicator
		RECT rcTemp(rcBounds);
		rcTemp.top += 32;
		rcTemp.bottom = rcTemp.top+10;
		rcTemp.left +=70;
		for (int i=0; i<m_nAntenna; ++i) 
		{
			rcTemp.right = rcTemp.left + 10;
			FillRect(di.hdcDraw, &rcTemp, (hb = (HBRUSH)::CreateSolidBrush(COLORREF(0x00ee0000))));
			rcTemp.left += 25;
		}
		::DeleteObject(hb);

		return S_OK;
	};

private:
	DWORD dwLastTick;
	long m_nDataCount;
	short m_nDataRate;
	short m_nAntenna;
	short m_nThermal;
	short m_bufferSize;
	BOOL m_acquireData;

public:
	LRESULT OnTimer(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
	if (wParam == 3442) 
	{
		CComBSTR sData("1");
		
		// create data stream
		if ((m_nDataCount % 2))
			sData = "1";
		else
			sData = "0";
		++m_nDataCount;
	
		// issue event
		Fire_DataStream(sData);

		// thermal values based on how much "work" is being performed
		DWORD dwCurrentTick = ::GetTickCount();
		if ((dwCurrentTick - dwLastTick) < 3000) 
		{
			Fire_ThermalValue(1);
			m_nDataCount = 501;
			m_nThermal = 3;
		}
		else if ((dwCurrentTick - dwLastTick) < 6000) 
		{
			Fire_ThermalValue(2);
			m_nThermal = 2;
		}
		else if ((dwCurrentTick - dwLastTick) < 10000) 
		{
			Fire_ThermalValue(3);
			m_nThermal = 1;
		}

		// store tick count
		dwLastTick = dwCurrentTick;

		// check maximum transmission
		if (m_nDataCount > 500) 
		{
			put_AcquireData(false);
			m_nDataCount = 0;
		}

		FireViewChange();
		bHandled = true;
	}
		return 0;
	}
};

#endif //__ATLACTIVEXCTL_H_
