// MFCActiveXCtl.cpp : Implementation of the CMFCActiveXCtrl ActiveX Control class.

#include "stdafx.h"
#include "MFCActiveX.h"
#include "MFCActiveXCtl.h"
#include "MFCActiveXPpg.h"
#include <atlbase.h>


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CMFCActiveXCtrl, COleControl)


/////////////////////////////////////////////////////////////////////////////
// Message map

BEGIN_MESSAGE_MAP(CMFCActiveXCtrl, COleControl)
	//{{AFX_MSG_MAP(CMFCActiveXCtrl)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Dispatch map

BEGIN_DISPATCH_MAP(CMFCActiveXCtrl, COleControl)
	//{{AFX_DISPATCH_MAP(CMFCActiveXCtrl)
	DISP_PROPERTY_NOTIFY(CMFCActiveXCtrl, "AcquireData", m_acquireData, OnAcquireDataChanged, VT_BOOL)
	DISP_PROPERTY_NOTIFY(CMFCActiveXCtrl, "BufferSize", m_bufferSize, OnBufferSizeChanged, VT_I2)
	DISP_FUNCTION(CMFCActiveXCtrl, "SetAntenna", SetAntenna, VT_ERROR, VTS_I2)
	//}}AFX_DISPATCH_MAP
	DISP_FUNCTION_ID(CMFCActiveXCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()


/////////////////////////////////////////////////////////////////////////////
// Event map

BEGIN_EVENT_MAP(CMFCActiveXCtrl, COleControl)
	//{{AFX_EVENT_MAP(CMFCActiveXCtrl)
	EVENT_CUSTOM("DataStream", FireDataStream, VTS_BSTR)
	EVENT_CUSTOM("ThermalValue", FireThermalValue, VTS_I2)
	//}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CMFCActiveXCtrl, 1)
	PROPPAGEID(CMFCActiveXPropPage::guid)
END_PROPPAGEIDS(CMFCActiveXCtrl)


/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CMFCActiveXCtrl, "MFCACTIVEX.MFCActiveXCtrl.1",
	0xd33e5f36, 0xcc5b, 0x11d2, 0x8f, 0xba, 0, 0x10, 0x5a, 0x5d, 0x8d, 0x6c)


/////////////////////////////////////////////////////////////////////////////
// Type library ID and version

IMPLEMENT_OLETYPELIB(CMFCActiveXCtrl, _tlid, _wVerMajor, _wVerMinor)


/////////////////////////////////////////////////////////////////////////////
// Interface IDs

const IID BASED_CODE IID_DMFCActiveX =
		{ 0xd33e5f34, 0xcc5b, 0x11d2, { 0x8f, 0xba, 0, 0x10, 0x5a, 0x5d, 0x8d, 0x6c } };
const IID BASED_CODE IID_DMFCActiveXEvents =
		{ 0xd33e5f35, 0xcc5b, 0x11d2, { 0x8f, 0xba, 0, 0x10, 0x5a, 0x5d, 0x8d, 0x6c } };


/////////////////////////////////////////////////////////////////////////////
// Control type information

static const DWORD BASED_CODE _dwMFCActiveXOleMisc =
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CMFCActiveXCtrl, IDS_MFCACTIVEX, _dwMFCActiveXOleMisc)


/////////////////////////////////////////////////////////////////////////////
// CMFCActiveXCtrl::CMFCActiveXCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CMFCActiveXCtrl

BOOL CMFCActiveXCtrl::CMFCActiveXCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	// TODO: Verify that your control follows apartment-model threading rules.
	// Refer to MFC TechNote 64 for more information.
	// If your control does not conform to the apartment-model rules, then
	// you must modify the code below, changing the 6th parameter from
	// afxRegApartmentThreading to 0.

	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_MFCACTIVEX,
			IDB_MFCACTIVEX,
			afxRegApartmentThreading,
			_dwMFCActiveXOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}


/////////////////////////////////////////////////////////////////////////////
// CMFCActiveXCtrl::CMFCActiveXCtrl - Constructor

CMFCActiveXCtrl::CMFCActiveXCtrl()
{
	InitializeIIDs(&IID_DMFCActiveX, &IID_DMFCActiveXEvents);

	// Initialize your control's instance data here.
	m_nDataRate = 100;
	m_nAntenna = 1;
	m_nDataCount = 0;
	m_bufferSize = 5;
	m_nThermal = 3;
}


/////////////////////////////////////////////////////////////////////////////
// CMFCActiveXCtrl::~CMFCActiveXCtrl - Destructor

CMFCActiveXCtrl::~CMFCActiveXCtrl()
{
	// TODO: Cleanup your control's instance data here.
}


/////////////////////////////////////////////////////////////////////////////
// CMFCActiveXCtrl::OnDraw - Drawing function

void CMFCActiveXCtrl::OnDraw(
			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
	// the background of the control represents the thermal indication
	switch (m_nThermal) 
	{
	case 1:
		pdc->FillSolidRect((LPCRECT)rcBounds, COLORREF(0x000000ff));
		break;
	case 2:
		pdc->FillSolidRect((LPCRECT)rcBounds, COLORREF(0x0000ffff));
		break;
	case 3:
		pdc->FillSolidRect((LPCRECT)rcBounds, COLORREF(0x0000ff00));
		break;
	}

	// provide a white area for the indicators
	CRect rcEmpty(rcBounds);
	rcEmpty.top = 9;
	rcEmpty.bottom = 25;
	rcEmpty.left = 9;
	rcEmpty.right = 92;
	pdc->FillSolidRect((LPCRECT)rcEmpty,COLORREF(0x000ffffff));
	rcEmpty.top = 29;
	rcEmpty.bottom = 45;
	rcEmpty.left = 9;
	rcEmpty.right = 136;
	pdc->FillSolidRect((LPCRECT)rcEmpty,COLORREF(0x000ffffff));

	// indicator labels
	pdc->SelectObject(::GetStockObject(ANSI_VAR_FONT));
	pdc->TextOut(rcBounds.left+10, rcBounds.top+10,"Power", 5);
	pdc->TextOut(rcBounds.left+10, rcBounds.top+30,"Antenna", 7);

	// draw power indicator
	CRect rcPower(rcBounds);
	rcPower.top += 12;
	rcPower.bottom = rcPower.top + 10;
	rcPower.left = 70;
	rcPower.right = rcPower.left + 10;
	if (m_acquireData)
		pdc->FillSolidRect((LPCRECT)rcPower,COLORREF(0x0000ff00));
	else
		pdc->FillSolidRect((LPCRECT)rcPower,COLORREF(0x000000ff));

	// draw antenna indicator
	CRect rcTemp(rcBounds);
	rcTemp.top += 32;
	rcTemp.bottom = rcTemp.top+10;
	rcTemp.left +=70;
	for (int i=0; i<m_nAntenna; ++i) 
	{
		rcTemp.right = rcTemp.left + 10;
		pdc->FillSolidRect((LPCRECT)rcTemp,COLORREF(0x00ee0000));
		rcTemp.left += 25;
	}
}


/////////////////////////////////////////////////////////////////////////////
// CMFCActiveXCtrl::DoPropExchange - Persistence support

void CMFCActiveXCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

	// TODO: Call PX_ functions for each persistent custom property.

}


/////////////////////////////////////////////////////////////////////////////
// CMFCActiveXCtrl::OnResetState - Reset control to default state

void CMFCActiveXCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange

	// TODO: Reset any other control state here.
}


/////////////////////////////////////////////////////////////////////////////
// CMFCActiveXCtrl::AboutBox - Display an "About" box to the user

void CMFCActiveXCtrl::AboutBox()
{
	CDialog dlgAbout(IDD_ABOUTBOX_MFCACTIVEX);
	dlgAbout.DoModal();
}


/////////////////////////////////////////////////////////////////////////////
// CMFCActiveXCtrl message handlers

SCODE CMFCActiveXCtrl::SetAntenna(short Antenna) 
{
	// the antenna selection identifies the supported data rate 
	m_nAntenna = Antenna;
	switch(Antenna) 
	{
	case 1:
		m_nDataRate = 100;
		break;
	case 2:
		m_nDataRate = 10;
		break;
	default:
		m_nDataRate = 5;
		break;
	}

	InvalidateControl();
	SetModifiedFlag();

	return S_OK;
}

void CMFCActiveXCtrl::OnAcquireDataChanged() 
{
	if (m_acquireData) 
	{
		SetTimer(3442, (1000/m_nDataRate)*500, NULL);
	}
	else 
	{
		KillTimer(3442);
	}
	SetModifiedFlag();
	InvalidateControl();
}

void CMFCActiveXCtrl::OnBufferSizeChanged() 
{
	// TODO: Add notification handler code

	SetModifiedFlag();
}

void CMFCActiveXCtrl::OnTimer(UINT nIDEvent) 
{
	if (nIDEvent == 3442) 
	{
		CString sData;
		
		// create data stream
		if ((m_nDataCount % 2))
			sData = "1";
		else
			sData = "0";
		++m_nDataCount;

		// convert data stream to BSTR
		BSTR bstrData = sData.AllocSysString();
		
		// issue event
		CComBSTR bs("test");
		FireDataStream(bstrData);//bstrData);

		// thermal values based on how much "work" is being performed
		DWORD dwCurrentTick = ::GetTickCount();
		if ((dwCurrentTick - dwLastTick) < 3000) 
		{
			FireThermalValue(1);
			m_nDataCount = 501;
			m_nThermal = 3;
		}
		else if ((dwCurrentTick - dwLastTick) < 6000) 
		{
			FireThermalValue(2);
			m_nThermal = 2;
		}
		else if ((dwCurrentTick - dwLastTick) < 10000) 
		{
			FireThermalValue(3);
			m_nThermal = 1;
		}

		// store tick count
		dwLastTick = dwCurrentTick;

		// check maximum transmission
		if (m_nDataCount > 500) 
		{
			m_acquireData = false;
			m_nDataCount = 0;
			OnAcquireDataChanged();
		}

		SetModifiedFlag();
		InvalidateControl();
		COleControl::OnTimer(nIDEvent);
	}
}	
