// TryDAOTableDef.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "TryDAOTableDef.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// The one and only application object

CWinApp theApp;

using namespace std;

static const TCHAR * getFieldType(short type)
{
   switch (type) {
   case dbBoolean:      return _T("dbBoolean");
   case dbByte:         return _T("dbByte");
   case dbInteger:      return _T("dbInteger");
   case dbLong:         return _T("dbLong");
   case dbCurrency:     return _T("dbCurrency");
   case dbSingle:       return _T("dbSingle");
   case dbDouble:       return _T("dbDouble");
   case dbDate:         return _T("dbDate");
   case dbText:         return _T("dbText");
   case dbLongBinary:   return _T("dbLongBinary");
   case dbMemo:         return _T("dbMemo");
   case dbGUID:         return _T("dbGUID");
   }

   return _T("Unknown");
}

static void dumpTable(CDaoDatabase *db, const TCHAR *tableName)
{
   CDaoTableDef tableDef(db);

   tableDef.Open(tableName);

   cout << _T("Table: ") << tableName << endl;

   CDaoFieldInfo fieldInfo;

   short numFields = tableDef.GetFieldCount();

   for (short i=0; i<numFields; i++) {
      tableDef.GetFieldInfo(i, fieldInfo);

      cout << _T("\t") << getFieldType(fieldInfo.m_nType)
           << _T("\t") << fieldInfo.m_lSize
           << _T("\t") << (const TCHAR *) fieldInfo.m_strName << endl;

   }

   tableDef.Close();
}

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;

	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: change error code to suit your needs
		cerr << _T("Fatal Error: MFC initialization failed") << endl;
		nRetCode = 1;
	}
	else
	{
      if (argc != 3) {
         cerr << _T("usage: TryDAOTableDef <mdb name> <table name>") << endl;
         return 1;
      }

      try {
         CDaoDatabase db;

         db.Open(argv[1]);

         dumpTable(&db, argv[2]);

         db.Close();
      }
      catch (CDaoException *xcp) {
         cerr << _T("Database exception: ") << (const TCHAR *) xcp->m_pErrorInfo->m_strDescription << endl;
         xcp->Delete();
      }

      AfxDaoTerm();
	}

	return nRetCode;
}


