// BooksRecordset.cpp : implementation file
//

#include "stdafx.h"
#include "TryODBCRecordset.h"
#include "BooksRecordset.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBooksRecordset

IMPLEMENT_DYNAMIC(CBooksRecordset, CRecordset)

CBooksRecordset::CBooksRecordset(CDatabase* pdb)
	: CRecordset(pdb)
{
	//{{AFX_FIELD_INIT(CBooksRecordset)
	m_BookId = 0;
	m_Title = _T("");
	m_PublisherId = 0;
	m_ISBN = _T("");
	m_RetailPrice = _T("");
	m_CategoryId = 0;
	m_TopicId = 0;
	m_nFields = 8;
	//}}AFX_FIELD_INIT
	m_nDefaultType = snapshot;
}


CString CBooksRecordset::GetDefaultConnect()
{
	return _T("ODBC;DSN=MS Access 97 Database");
}

CString CBooksRecordset::GetDefaultSQL()
{
	return _T("[Books]");
}

void CBooksRecordset::DoFieldExchange(CFieldExchange* pFX)
{
	//{{AFX_FIELD_MAP(CBooksRecordset)
	pFX->SetFieldType(CFieldExchange::outputColumn);
	RFX_Long(pFX, _T("[BookId]"), m_BookId);
	RFX_Text(pFX, _T("[Title]"), m_Title);
	RFX_Long(pFX, _T("[PublisherId]"), m_PublisherId);
	RFX_Date(pFX, _T("[PublicationDate]"), m_PublicationDate);
	RFX_Text(pFX, _T("[ISBN]"), m_ISBN);
	RFX_Text(pFX, _T("[RetailPrice]"), m_RetailPrice);
	RFX_Long(pFX, _T("[CategoryId]"), m_CategoryId);
	RFX_Long(pFX, _T("[TopicId]"), m_TopicId);
	//}}AFX_FIELD_MAP
}

/////////////////////////////////////////////////////////////////////////////
// CBooksRecordset diagnostics

#ifdef _DEBUG
void CBooksRecordset::AssertValid() const
{
	CRecordset::AssertValid();
}

void CBooksRecordset::Dump(CDumpContext& dc) const
{
	CRecordset::Dump(dc);
}
#endif //_DEBUG
