#ifndef books_h
#define books_h

class CBooks : public CADORecordBinding {
public:
   LONG     m_BookId;
   LONG     m_CategoryId;
   TCHAR    m_ISBN[13];
   DATE     m_PublicationDate;
   LONG     m_PublisherId;
   CURRENCY m_RetailPrice;
   TCHAR    m_Title[251];
   LONG     m_TopicId;

   ULONG    m_stsBookId;
   ULONG    m_stsCategoryId;
   ULONG    m_stsISBN;
   ULONG    m_stsPublicationDate;
   ULONG    m_stsPublisherId;
   ULONG    m_stsRetailPrice;
   ULONG    m_stsTitle;
   ULONG    m_stsTopicId;

BEGIN_ADO_BINDING(CBooks)
   ADO_NUMERIC_ENTRY(1, adInteger, m_BookId, 10, 0, m_stsBookId, false)
   ADO_VARIABLE_LENGTH_ENTRY2(2, adVarChar, m_Title, sizeof(m_Title), m_stsTitle, true)
   ADO_NUMERIC_ENTRY(3, adInteger, m_PublisherId, 10, 0, m_stsPublisherId, true)
   ADO_FIXED_LENGTH_ENTRY(4, adDate, m_PublicationDate, m_stsPublicationDate, true)
   ADO_VARIABLE_LENGTH_ENTRY2(5, adChar, m_ISBN, sizeof(m_ISBN), m_stsISBN, true)
   ADO_FIXED_LENGTH_ENTRY(6, adCurrency, m_RetailPrice, m_stsRetailPrice, true)
   ADO_NUMERIC_ENTRY(7, adInteger, m_CategoryId, 10, 0, m_stsCategoryId, true)
   ADO_NUMERIC_ENTRY(8, adInteger, m_TopicId, 10, 0, m_stsTopicId, true)
END_ADO_BINDING()

   // You may wish to call this function if you are inserting a record and wish to
   // initialize all the fields, if you are not going to explicitly set all of them.
   void ClearRecord()
   {
      memset(this, 0, sizeof(*this));
   }
};

#endif

