// Books.H : Declaration of the CBooks class

#ifndef __BOOKS_H_
#define __BOOKS_H_

extern wchar_t *g_mdbLocation;

class CBooksAccessor
{
public:
	LONG m_BookId;
	LONG m_CategoryId;
	TCHAR m_ISBN[13];
	DATE m_PublicationDate;
	LONG m_PublisherId;
	CURRENCY m_RetailPrice;
	TCHAR m_Title[251];
	LONG m_TopicId;

BEGIN_ACCESSOR_MAP(CBooksAccessor, 2)
   BEGIN_ACCESSOR(0, true)
	 COLUMN_ENTRY(1, m_BookId)
	 COLUMN_ENTRY(2, m_Title)
	 COLUMN_ENTRY(3, m_PublisherId)
	 COLUMN_ENTRY_TYPE(4, DBTYPE_DATE, m_PublicationDate)
	 COLUMN_ENTRY(5, m_ISBN)
	 COLUMN_ENTRY_TYPE(6, DBTYPE_CY, m_RetailPrice)
	 COLUMN_ENTRY(7, m_CategoryId)
	 COLUMN_ENTRY(8, m_TopicId)
   END_ACCESSOR()
   BEGIN_ACCESSOR(1, false)
    COLUMN_ENTRY(5, m_ISBN)
   END_ACCESSOR()
END_ACCESSOR_MAP()


	// You may wish to call this function if you are inserting a record and wish to
	// initialize all the fields, if you are not going to explicitly set all of them.
	void ClearRecord()
	{
		memset(this, 0, sizeof(*this));
	}
};

class CBooks : public CTable<CAccessor<CBooksAccessor> >
{
public:
	HRESULT Open()
	{
		HRESULT		hr;

		hr = OpenDataSource();
		if (FAILED(hr))
			return hr;

		return OpenRowset();
	}
	HRESULT OpenDataSource()
	{
		HRESULT		hr;
		CDataSource db;
		CDBPropSet	dbinit(DBPROPSET_DBINIT);

		dbinit.AddProperty(DBPROP_AUTH_CACHE_AUTHINFO, true);
		dbinit.AddProperty(DBPROP_AUTH_ENCRYPT_PASSWORD, false);
		dbinit.AddProperty(DBPROP_AUTH_MASK_PASSWORD, false);
		dbinit.AddProperty(DBPROP_AUTH_PASSWORD, OLESTR(""));
		dbinit.AddProperty(DBPROP_AUTH_PERSIST_ENCRYPTED, false);
		dbinit.AddProperty(DBPROP_AUTH_PERSIST_SENSITIVE_AUTHINFO, false);
		dbinit.AddProperty(DBPROP_AUTH_USERID, OLESTR("Admin"));
		dbinit.AddProperty(DBPROP_INIT_DATASOURCE, g_mdbLocation);
		dbinit.AddProperty(DBPROP_INIT_MODE, (long)16);
		dbinit.AddProperty(DBPROP_INIT_PROMPT, (short)4);
		dbinit.AddProperty(DBPROP_INIT_PROVIDERSTRING, OLESTR(";COUNTRY=0;CP=1252;LANGID=0x0409"));
		dbinit.AddProperty(DBPROP_INIT_LCID, (long)1033);
		hr = db.Open(_T("Microsoft.Jet.OLEDB.3.51"), &dbinit);
		if (FAILED(hr))
			return hr;

		return m_session.Open(db);
	}
	HRESULT OpenRowset()
	{
		// Set properties for open
		CDBPropSet	propset(DBPROPSET_ROWSET);
		propset.AddProperty(DBPROP_IRowsetChange, true);
		propset.AddProperty(DBPROP_UPDATABILITY, DBPROPVAL_UP_CHANGE | DBPROPVAL_UP_INSERT | DBPROPVAL_UP_DELETE);

		return CTable<CAccessor<CBooksAccessor> >::Open(m_session, _T("Books"), &propset);
	}
	CSession	m_session;
};

#endif // __BOOKS_H_
