// EventDefineView.cpp : implementation file
//

#include "stdafx.h"

#include "MainFrm.h"

#include "UNL_MultiEd.h"
#include "EventDefineView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEventDefineView

IMPLEMENT_DYNCREATE(CEventDefineView, CFormView)

CEventDefineView::CEventDefineView()
	: CFormView(CEventDefineView::IDD)
{
	//{{AFX_DATA_INIT(CEventDefineView)
	m_sEventName = _T("");
	//}}AFX_DATA_INIT
}

CEventDefineView::~CEventDefineView()
{
}

void CEventDefineView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEventDefineView)
	DDX_Control(pDX, IDC_ALL_EVENTS, m_slEvents);
	DDX_Control(pDX, IDC_PARTICIPANTS, m_slParticipants);
	DDX_Control(pDX, IDC_EVENT_PARTICIPANTS, m_slEventParticipants);
	DDX_Text(pDX, IDC_EVENT_NAME, m_sEventName);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEventDefineView, CFormView)
	//{{AFX_MSG_MAP(CEventDefineView)
	ON_BN_CLICKED(IDC_ADD_TO_EVENT, OnAddToEvent)
	ON_BN_CLICKED(IDC_CANCEL_EVENT, OnCancelEvent)
	ON_BN_CLICKED(IDC_CREATE_NEW_EVENT, OnCreateNewEvent)
	ON_BN_CLICKED(IDC_REMOVE_FROM_EVENT, OnRemoveFromEvent)
	ON_BN_CLICKED(IDC_SAVE_EVENT, OnSaveEvent)
	ON_BN_CLICKED(IDC_EDIT_EVENT, OnEditEvent)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_GET_EVENTS, OnGetEvents)
	ON_BN_CLICKED(IDC_SELECT_EVENT, OnSelectEvent)
	ON_LBN_DBLCLK(IDC_ALL_EVENTS, OnSelectEvent)
	ON_LBN_DBLCLK(IDC_PARTICIPANTS, OnAddToEvent)
	ON_LBN_DBLCLK(IDC_EVENT_PARTICIPANTS, OnRemoveFromEvent)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEventDefineView diagnostics

#ifdef _DEBUG
void CEventDefineView::AssertValid() const
{
	CFormView::AssertValid();
}

void CEventDefineView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CEventDefineView message handlers

void CEventDefineView::OnAddToEvent() 
{
    UpdateData(TRUE);

   	CUNL_MultiEdApp* pApp = (CUNL_MultiEdApp*)AfxGetApp();
    CXEventRecorder *ourEventRecorder = pApp->GetEventRecorder();

    if (ourEventRecorder == NULL)
    {
        AfxMessageBox("We have a problem! The Event Recorder has not been initialized");
        return;
    }

    CList <CXEvent *, CXEvent *>             *elEvents = ourEventRecorder->GetEvents();
    CList <CXParticipant *, CXParticipant *> *plParticipants = ourEventRecorder->GetParticipants();

    CXEvent         *ourEvent;      //  We'll need this later..
    CXParticipant   *ourParticipant;
    
    CString strEventName = ourEventRecorder->GetEventName();

    //Find our event
    POSITION pos = elEvents->GetHeadPosition();
    while(pos)
    {
        ourEvent = elEvents->GetNext(pos);
        if (ourEvent->GetEventName() == strEventName)break;
    }

    int iPartSel = m_slParticipants.GetCurSel();
	
	// insist that one item be selected
    if (LB_ERR != m_slParticipants.GetCurSel())
    {
		CString sSelParticipant;
		m_slParticipants.GetText(iPartSel, sSelParticipant);
		DWORD wData = m_slParticipants.GetItemData(iPartSel);
        int iEventPart = m_slEventParticipants.AddString(sSelParticipant);
        m_slEventParticipants.SetItemData(iEventPart, (DWORD)wData);

        // We need to find our Participant and add them to our Event..

        int ndelimiter = sSelParticipant.Find(",");

        int strLength = sSelParticipant.GetLength();
        CString strLastName = sSelParticipant.Left(ndelimiter);
        CString strFirstName = sSelParticipant.Right(strLength - ndelimiter - 1);

        pos = plParticipants->GetHeadPosition();
        while (pos)
        {
            ourParticipant = plParticipants->GetNext(pos);
            if ((ourParticipant->GetLastName() == strLastName) &&
                (ourParticipant->GetFirstName() == strFirstName))
            {
                ourEvent->AddParticipantToEvent(ourParticipant);
                break;
            }
        }

        m_slParticipants.DeleteString(iPartSel);
    }

	UpdateData(FALSE);

}

void CEventDefineView::OnCancelEvent() 
{
}

void CEventDefineView::OnCreateNewEvent() 
{
    UpdateData(TRUE);

   	CUNL_MultiEdApp* pApp = (CUNL_MultiEdApp*)AfxGetApp();
    CXEventRecorder *ourEventRecorder = pApp->GetEventRecorder();

    if (ourEventRecorder == NULL)
    {
        ourEventRecorder = new CXEventRecorder();
        pApp->SetEventRecorder(ourEventRecorder);
    }

    CXEvent *ourEvent = new CXEvent();

    ourEvent->SetEventName(m_sEventName);
    ourEventRecorder->AddEvent(ourEvent);
}

void CEventDefineView::OnRemoveFromEvent() 
{
	// TODO: Add your control notification handler code here
	
}

void CEventDefineView::OnSaveEvent() 
{
	// TODO: Add your control notification handler code here
	
}

void CEventDefineView::OnEditEvent() 
{
	// TODO: Add your control notification handler code here
	
}


BOOL CEventDefineView::OnInitDialog() 
{
    UpdateData(TRUE);

	CFormView::OnInitialUpdate();

   	CUNL_MultiEdApp* pApp = (CUNL_MultiEdApp*)AfxGetApp();

    CXEventRecorder *ourEventRecorder = pApp->GetEventRecorder();


    if (ourEventRecorder == NULL)
    {
        AfxMessageBox("We have a problem! The Event Recorder has not been initialized");
        return FALSE;
    }

    CList <CXEvent *, CXEvent *>                *ourEvents;
    CList <CXParticipant *, CXParticipant *>    *ourParticipants;

    ourEvents       = ourEventRecorder->GetEvents();
    ourParticipants = ourEventRecorder->GetParticipants();

    // Fill our Event Combo Box
	POSITION pos = ourEvents->GetHeadPosition();
    while (pos)
    {
        CXEvent *ourEvent = ourEvents->GetNext(pos);
        CString strTemp = ourEvent->GetEventName();

        m_slEvents.AddString((const char *)strTemp);
    }

	UpdateData(FALSE);

    return TRUE;
}

void CEventDefineView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	CMainFrame* pFrame=(CMainFrame*) AfxGetMainWnd();	
	pFrame->SetWindowText("UNL_MultiEd - Event Definition View");
}

void CEventDefineView::OnGetEvents() 
{
    UpdateData(TRUE);

	CFormView::OnInitialUpdate();

   	CUNL_MultiEdApp* pApp = (CUNL_MultiEdApp*)AfxGetApp();

    CXEventRecorder *ourEventRecorder = pApp->GetEventRecorder();

    if (ourEventRecorder == NULL)
    {
        AfxMessageBox("We have a problem! The Event Recorder has not been initialized");
        return;
    }

    CList <CXEvent *, CXEvent *>                *ourEvents;
    CList <CXParticipant *, CXParticipant *>    *ourParticipants;

    ourEvents       = ourEventRecorder->GetEvents();
    ourParticipants = ourEventRecorder->GetParticipants();

    m_slEvents.ResetContent();

    //Fill our Event List Box..
    int nTmpIndx = 0;

	POSITION pos = ourEvents->GetHeadPosition();
    while (pos)
    {
        CXEvent *ourEvent = ourEvents->GetNext(pos);
        CString strTemp = ourEvent->GetEventName();

        nTmpIndx = m_slEvents.AddString(strTemp);
    }
    
    nTmpIndx = 0;

    pos = ourParticipants->GetHeadPosition();
    while (pos)
    {
        CXParticipant *ourParticipant = ourParticipants->GetNext(pos);
        CString strTemp = ourParticipant->GetLastName() + "," + ourParticipant->GetFirstName();

        nTmpIndx = m_slParticipants.AddString(strTemp);
    }

	UpdateData(FALSE);
	
}

void CEventDefineView::OnSelectEvent() 
{

    UpdateData(TRUE);

   	CUNL_MultiEdApp* pApp = (CUNL_MultiEdApp*)AfxGetApp();
    CXEventRecorder *ourEventRecorder = pApp->GetEventRecorder();
    if (ourEventRecorder == NULL)
    {
        AfxMessageBox("We have a problem! The Event Recorder has not been initialized");
        return;
    }

    int nEventSelected = m_slEvents.GetCurSel();
    m_slEvents.GetText(nEventSelected, m_sEventName);

    ourEventRecorder->SetEvent(nEventSelected, m_sEventName);
}
