// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "UNL_MultiEd.h"

#include "MainFrm.h"

#include "EventTallyDoc.h"
#include "EventDefineDoc.h"
#include "PartDoc.h"

#include "cx_eventrecorder.h"


// StringKeeper is a global class that keeps our string list
//  to be used across all of the documents.
//////////////////////////////////////////////////////////////////////////////
//#include "gu_StringKeeper.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_FILE_NEW, OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_FILE_FINAL_TALLY, OnReportFinalTally)
	ON_COMMAND(ID_VIEW_PART_ENTRY, OnViewPartEntry)
	ON_COMMAND(ID_VIEW_EVENT_TALLY, OnViewEventTally)
	ON_COMMAND(ID_VIEW_EVENT_DEFINE, OnViewEventDefine)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CMDIFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


void CMainFrame::OnFileNew() 
{
    /*************************************************************
    **      First get our app, and then position to the first   **
    **      template.  Iterate our templates, until we find     **
    **      the desired one.                                    **
    *************************************************************/
   	CUNL_MultiEdApp* pApp = (CUNL_MultiEdApp*)AfxGetApp();

	POSITION curTemplatePos = pApp->GetFirstDocTemplatePosition();

	while(curTemplatePos != NULL)
	{
		CDocTemplate* curTemplate = 
			pApp->GetNextDocTemplate(curTemplatePos);
		CString str;
		curTemplate->GetDocString(str, CDocTemplate::docName);
		if(str == _T("PartForm"))
		{
        	CPartDoc* pPartDoc;
			pPartDoc = (CPartDoc*)curTemplate->OpenDocumentFile(NULL);
			return;
		}
	}
	AfxMessageBox("Why are we here ??");
}

void CMainFrame::OnFileOpen() 
{
    CString sFileName;

	CUNL_MultiEdApp* pApp = (CUNL_MultiEdApp*)AfxGetApp();

    CXEventRecorder *ourEventRecorder = pApp->GetEventRecorder();

    static TCHAR szFilter[] = _T("Event Recorder Files (*.erx)|*.erx|AllFiles(*.*)|*.*|") ;

    //////////////////////////////////////////////////////////
    //	Define the common dialog for opening the file..		//
    //////////////////////////////////////////////////////////
    CFileDialog dlg( TRUE, _T("*.erx"), NULL,
                    OFN_HIDEREADONLY | OFN_PATHMUSTEXIST, szFilter,NULL)  ;

    dlg.m_ofn.lpstrTitle = "Event Recorder File";
    dlg.m_ofn.lpstrInitialDir = CString("C:\\EventRecorderFiles\\");

    /*************************************************************************
    **  Here we want to give them the chance to use an ASCII delimited file **
    **  to load the events and participants.  Then open the Event Tally     **
    **  document to let them continue working with the events.  If they     **
    **  cancel, then start with the participants view..                     **
    *************************************************************************/

	if (IDOK != dlg.DoModal())
    {

	    POSITION curTemplatePos = pApp->GetFirstDocTemplatePosition();

        // Start with the Participants view.. 
	    while(curTemplatePos != NULL)
	    {
		    CDocTemplate* curTemplate = 
			    pApp->GetNextDocTemplate(curTemplatePos);
		    CString str;
		    curTemplate->GetDocString(str, CDocTemplate::docName);
		    if(str == _T("PartForm"))
		    {
                CPartDoc* pPartDoc;
			    pPartDoc = (CPartDoc*)curTemplate->OpenDocumentFile(NULL);
			    return;
		    }
        }
    }
    else
    {
        sFileName = dlg.GetPathName();

        //  We aren't created yet, so create us..
        if (ourEventRecorder == NULL)
        {
            ourEventRecorder = new CXEventRecorder();
            pApp->SetEventRecorder(ourEventRecorder);
        }

        //Load in our Event information::
        ourEventRecorder->LoadEvents(sFileName);

	    POSITION curTemplatePos = pApp->GetFirstDocTemplatePosition();

        // Start with the Participants view.. 
	    while(curTemplatePos != NULL)
	    {
		    CDocTemplate* curTemplate = 
			    pApp->GetNextDocTemplate(curTemplatePos);
		    CString str;
		    curTemplate->GetDocString(str, CDocTemplate::docName);
		    if(str == _T("EventTallyForm"))
		    {
                CEventTallyDoc* pEVTallyDoc;
			    pEVTallyDoc = (CEventTallyDoc*)curTemplate->OpenDocumentFile(NULL);
			    return;
		    }
        }
    }
}

void CMainFrame::OnReportFinalTally() 
{
	// TODO: Add your command handler code here
	
}

void CMainFrame::OnViewPartEntry() 
{

    CUNL_MultiEdApp* pApp = (CUNL_MultiEdApp*)AfxGetApp();

	POSITION curTemplatePos = pApp->GetFirstDocTemplatePosition();

    // Start with the Participants view.. 
	while(curTemplatePos != NULL)
	{
		CDocTemplate* curTemplate = 
			pApp->GetNextDocTemplate(curTemplatePos);
		CString str;
		curTemplate->GetDocString(str, CDocTemplate::docName);
		if(str == _T("PartForm"))
		{
            CPartDoc* pPartDoc;
			pPartDoc = (CPartDoc*)curTemplate->OpenDocumentFile(NULL);
			return;
		}
    }
}

void CMainFrame::OnViewEventTally() 
{
	// TODO: Add your command handler code here
	
}

void CMainFrame::OnViewEventDefine() 
{

    CUNL_MultiEdApp* pApp = (CUNL_MultiEdApp*)AfxGetApp();

	POSITION curTemplatePos = pApp->GetFirstDocTemplatePosition();

    // Start with the Participants view.. 
	while(curTemplatePos != NULL)
	{
		CDocTemplate* curTemplate = 
			pApp->GetNextDocTemplate(curTemplatePos);
		CString str;
		curTemplate->GetDocString(str, CDocTemplate::docName);
		if(str == _T("EventDefineForm"))
		{
            CEventDefineDoc* pEventDefineDoc;
			pEventDefineDoc = (CEventDefineDoc*)curTemplate->OpenDocumentFile(NULL);
			return;
		}
    }
	
}
