// ParticipantView.cpp : implementation file
//

#include "stdafx.h"
#include "UNL_MultiEd.h"
#include "ParticipantView.h"

#include "cx_eventrecorder.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CParticipantView

IMPLEMENT_DYNCREATE(CParticipantView, CFormView)

CParticipantView::CParticipantView()
	: CFormView(CParticipantView::IDD)
{
	//{{AFX_DATA_INIT(CParticipantView)
	m_sFirstName = _T("");
	m_sLastName = _T("");
	m_sTeam = _T("");
	//}}AFX_DATA_INIT
}

CParticipantView::~CParticipantView()
{
}

void CParticipantView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CParticipantView)
	DDX_Text(pDX, IDC_PART_FIRST_NAME, m_sFirstName);
	DDX_Text(pDX, IDC_PART_LAST_NAME, m_sLastName);
	DDX_Text(pDX, IDC_PART_TEAM, m_sTeam);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CParticipantView, CFormView)
	//{{AFX_MSG_MAP(CParticipantView)
	ON_BN_CLICKED(IDC_ENTER_PART, OnEnterPart)
	ON_BN_CLICKED(IDC_CANCEL_ENTRY, OnCancelEntry)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CParticipantView diagnostics

#ifdef _DEBUG
void CParticipantView::AssertValid() const
{
	CFormView::AssertValid();
}

void CParticipantView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CParticipantView message handlers

void CParticipantView::OnEnterPart() 
{

    /*********************************************************
    **  Here we want to:                                    **
    **                                                      **
    **      Create a CXParticipant object                   **
    **      Get our input data                              **
    **      Fill in that Data..                             **
    **      Add it to the CList in our CXEventRecorder      **
    *********************************************************/

   	CUNL_MultiEdApp* pApp = (CUNL_MultiEdApp*)AfxGetApp();

    CXEventRecorder *ourEventRecorder = pApp->GetEventRecorder();

    UpdateData(TRUE);

    CXParticipant *ourParticipant = new CXParticipant(  m_sLastName,
                                                        m_sFirstName,
                                                        m_sTeam );

    //  We aren't created yet, so create us..
    if (ourEventRecorder == NULL)
    {
        ourEventRecorder = new CXEventRecorder();
        pApp->SetEventRecorder(ourEventRecorder);
    }

    ourEventRecorder->AddParticipant(ourParticipant);
}

void CParticipantView::OnCancelEntry() 
{
}
