// UNL_MultiEd.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "UNL_MultiEd.h"

#include "MainFrm.h"
#include "ChildFrm.h"
#include "UNL_MultiEdDoc.h"
#include "UNL_MultiEdView.h"

#include "PartChildFrame.h"
#include "PartDoc.h"
#include "ParticipantView.h"

#include "EventDefChildFrame.h"
#include "EventDefineDoc.h"
#include "EventDefineView.h"

#include "EventTallyChildFrame.h"
#include "EventTallyDoc.h"
#include "EventTallyView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CUNL_MultiEdApp

BEGIN_MESSAGE_MAP(CUNL_MultiEdApp, CWinApp)
	//{{AFX_MSG_MAP(CUNL_MultiEdApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUNL_MultiEdApp construction

CUNL_MultiEdApp::CUNL_MultiEdApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CUNL_MultiEdApp object

CUNL_MultiEdApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CUNL_MultiEdApp initialization

BOOL CUNL_MultiEdApp::InitInstance()
{
	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	LoadStdProfileSettings(10);  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(
		IDR_EDIT_TYPE,
		RUNTIME_CLASS(CUNL_MultiEdDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CUNL_MultiEdView));
	AddDocTemplate(pDocTemplate);

	//	Add Document for Participant View
	CMultiDocTemplate* pDoc2Template;
	pDoc2Template = new CMultiDocTemplate(
		IDR_PARTICIPANT_TYPE,
		RUNTIME_CLASS(CPartDoc),
		RUNTIME_CLASS(CPartChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CParticipantView));
	AddDocTemplate(pDoc2Template);

    
	//	Add Document for EventDefine  View
	CMultiDocTemplate* pDoc3Template;
	pDoc3Template = new CMultiDocTemplate(
		IDR_EVENT_DEFINE_TYPE,
		RUNTIME_CLASS(CEventDefineDoc),
		RUNTIME_CLASS(CEventDefChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CEventDefineView));
	AddDocTemplate(pDoc3Template);

	//	Add Document for EventDefine  View
	CMultiDocTemplate* pDoc4Template;
	pDoc4Template = new CMultiDocTemplate(
		IDR_EVENT_TALLY_TYPE,
		RUNTIME_CLASS(CEventTallyDoc),
		RUNTIME_CLASS(CEventTallyChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CEventTallyView));
	AddDocTemplate(pDoc4Template);

    /*  TODO:  Create these dialogs...
    *****************************************************
	//	Add Document for EventDefine  View
	CMultiDocTemplate* pDoc5Template;
	pDoc5Template = new CMultiDocTemplate(
		IDR_EVENT_DEFINE_TYPE,
		RUNTIME_CLASS(CTallyTotalDoc),
		RUNTIME_CLASS(CTallyTotalChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CTallyTotalView));
	AddDocTemplate(pDoc5Template);

    */


	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	if (CCommandLineInfo::FileNew == cmdInfo.m_nShellCommand)
		cmdInfo.m_nShellCommand = CCommandLineInfo::FileNothing;

	if (!ProcessShellCommand(cmdInfo)) return FALSE;

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The main window has been initialized, so show and update it.
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();

	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CUNL_MultiEdApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CUNL_MultiEdApp message handlers


void
CUNL_MultiEdApp::SetEventRecorder(CXEventRecorder *pEventRecorder)
{
    m_pEventRecorder = pEventRecorder;
}
    
CXEventRecorder*
CUNL_MultiEdApp::GetEventRecorder()
{
    return m_pEventRecorder;
}

