// contextmgr.cpp

#include "gu_contextmgr.h"
//#include "gu_utils.h"

#include <stdafx.h>
#include "XCAT.h"

// MDI Children
#include "XView_ChildFrame.h"   

// Documents
#include "XTPageSpecDoc.h"
#include "XTArticleDoc.h"

#include "XCPageSpecDoc.h"
#include "XCArticleDoc.h"

// Views
#include "xtemppageview.h"
#include "xtemparticleview.h"

#include "xcontpageview.h"
#include "xcontarticleview.h"

#include "IpFrame.h"

#define MAX_PATH_LEN 512

///////////////////////////////////////////////////////////////////////////////
// The following mask and lookup table define the behavior of the context 
// switching in the JMCATS application.  These define what windows (views)
// because of a change in context from another window (view).
///////////////////////////////////////////////////////////////////////////////

typedef unsigned int XWMask;

CXCATContextManager::CXCATContextManager()
{
}


CXCATContextManager::~CXCATContextManager()
{
}



CMultiDocTemplate*	
CXCATContextManager::GetDocTemplate(int xwtTemp)
{
}



void
CXCATContextManager::CloseAllFrameWnd()
{
    CMDIFrameWnd *pMDIFrame = (CMDIFrameWnd *)AfxGetApp()->m_pMainWnd;
    CMDIChildWnd *pMDIChild = pMDIFrame->MDIGetActive();
    CMDIChildWnd *pMDITemp  = NULL;

    // looping through all windows
    while (NULL != pMDIChild)
    {
        pMDITemp = pMDIChild;
        pMDIChild->SendMessage(WM_CLOSE, 0, 0L);
        pMDIChild = pMDIFrame->MDIGetActive();
        if (pMDITemp == pMDIChild)
        {
            // window did not want to close
            break;
        }
    }
}

void
CXCATContextManager::OpenNewDocument(EXCATWindowType xwtDocType)
{

	CXTPageSpecDoc* pTPSDoc;
	CXTArticleDoc*	pTADoc;
	CXCPageSpecDoc* pCPSDoc;
	CXCArticleDoc*	pCADoc;

//	CRuntimeClass* pNewViewClass;
//	CCreateContext context;

    switch (xwtDocType)
	{
		case XWT_TEMP_PAGE:

			pTPSDoc = (CXTPageSpecDoc*)
				map_mdtDocumentTemplates[XWT_TEMP_PAGE]->OpenDocumentFile(NULL,TRUE);
			//OpenView(pTPSDoc, XWT_TEMP_PAGE);
            // Now transfer ownership of CX Classes..
            pTPSDoc->SetPageSpec(p_cxpThePageSpec);
            p_cxpThePageSpec = NULL;
			//pNewViewClass = RUNTIME_CLASS(CXTempPageView);
	        //context.m_pNewViewClass = pNewViewClass;
	        //context.m_pCurrentDoc = pTPSDoc;
			break;

		case XWT_TEMP_ARTICLE:

			pTADoc = (CXTArticleDoc*)
				map_mdtDocumentTemplates[XWT_TEMP_ARTICLE]->OpenDocumentFile(NULL,TRUE);
			//OpenView(pTADoc, XWT_TEMP_ARTICLE);
            // Now transfer ownership of CX Classes..
            pTADoc->SetPageSpec(p_cxpThePageSpec);
            p_cxpThePageSpec = NULL;
			//pNewViewClass = RUNTIME_CLASS(CXTempArticleView);
	        //context.m_pNewViewClass = pNewViewClass;
	        //context.m_pCurrentDoc = pTADoc;
			break;

		case XWT_CONT_PAGE:

			pCPSDoc = (CXCPageSpecDoc*)
				map_mdtDocumentTemplates[XWT_CONT_PAGE]->OpenDocumentFile(NULL,TRUE);
            pCPSDoc->SetPageSpec(p_cxpThePageSpec);
            p_cxpThePageSpec = NULL;
			//OpenView(pCPSDoc, XWT_CONT_PAGE);
            // Now transfer ownership of CX Classes..
			//pNewViewClass = RUNTIME_CLASS(CXContPageView);
	        //context.m_pNewViewClass = pNewViewClass;
	        //context.m_pCurrentDoc = pCPSDoc;
			break;

		case XWT_CONT_ARTICLE:

			pCADoc = (CXCArticleDoc*)
				map_mdtDocumentTemplates[XWT_CONT_ARTICLE]->OpenDocumentFile(NULL,TRUE);
			//OpenView(pCADoc, XWT_CONT_ARTICLE);
            // Now transfer ownership of CX Classes..
            pCADoc->SetPageSpec(p_cxpThePageSpec);
            p_cxpThePageSpec = NULL;
			//pNewViewClass = RUNTIME_CLASS(CXContArticleView);
	        //context.m_pNewViewClass = pNewViewClass;
	        //context.m_pCurrentDoc = pCADoc;
			break;
	}

}

void
CXCATContextManager::OpenView(CXTPageSpecDoc* pnewDoc, EXCATWindowType xwtViewType)
{
    CFrameWnd* pNewFrame = NULL;

    pNewFrame = 
        map_mdtDocumentTemplates[xwtViewType]->CreateNewFrame(pnewDoc, NULL);

    ASSERT(NULL != pNewFrame);
   
	map_mdtDocumentTemplates[xwtViewType]->InitialUpdateFrame(pNewFrame,pnewDoc,TRUE);

    pNewFrame->GetActiveView();

    pnewDoc->UpdateAllViews(NULL,0,NULL);
}



void
CXCATContextManager::OpenView(CXTArticleDoc* pnewDoc, EXCATWindowType xwtViewType)
{
    CFrameWnd* pNewFrame = NULL;

    pNewFrame = 
        map_mdtDocumentTemplates[xwtViewType]->CreateNewFrame(pnewDoc, NULL);

    ASSERT(NULL != pNewFrame);
   
	map_mdtDocumentTemplates[xwtViewType]->InitialUpdateFrame(pNewFrame,pnewDoc,TRUE);

    pNewFrame->GetActiveView();

    pnewDoc->UpdateAllViews(NULL,0,NULL);
}



void
CXCATContextManager::OpenView(CXCPageSpecDoc* pnewDoc, EXCATWindowType xwtViewType)
{
    CFrameWnd* pNewFrame = NULL;

    pNewFrame = 
        map_mdtDocumentTemplates[xwtViewType]->CreateNewFrame(pnewDoc, NULL);

    ASSERT(NULL != pNewFrame);
   
	map_mdtDocumentTemplates[xwtViewType]->InitialUpdateFrame(pNewFrame,pnewDoc,TRUE);

    pNewFrame->GetActiveView();

    pnewDoc->UpdateAllViews(NULL,0,NULL);
}



void
CXCATContextManager::OpenView(CXCArticleDoc* pnewDoc, EXCATWindowType xwtViewType)
{
    CFrameWnd* pNewFrame = NULL;

    pNewFrame = 
        map_mdtDocumentTemplates[xwtViewType]->CreateNewFrame(pnewDoc, NULL);

    ASSERT(NULL != pNewFrame);
   
	map_mdtDocumentTemplates[xwtViewType]->InitialUpdateFrame(pNewFrame,pnewDoc,TRUE);
    
    pNewFrame->GetActiveView();

    pnewDoc->UpdateAllViews(NULL,0,NULL);
}


//////////////////////////////////////////////////////////////////////////////
//	Called by any of the XCAT document upon there removal.					//
//																			//
//		Remove the Document from the Document Template, and then remove it	//
//		from it's Document Manager's List.  Then remove the Document		//
//		Document Manager													//
//////////////////////////////////////////////////////////////////////////////
void                  
CXCATContextManager::SignalDocumentDeath(CXTPageSpecDoc* pDeceasedDoc,
										 EXCATWindowType xwtDeceased)
{
	map_mdtDocumentTemplates[xwtDeceased]->RemoveDocument((CDocument*)pDeceasedDoc);
}

void                  
CXCATContextManager::SignalDocumentDeath(CXTArticleDoc* pDeceasedDoc,
										 EXCATWindowType xwtDeceased)
{
	map_mdtDocumentTemplates[xwtDeceased]->RemoveDocument((CDocument*)pDeceasedDoc);
}

void                  
CXCATContextManager::SignalDocumentDeath(CXCPageSpecDoc* pDeceasedDoc,
										 EXCATWindowType xwtDeceased)
{
	map_mdtDocumentTemplates[xwtDeceased]->RemoveDocument((CDocument*)pDeceasedDoc);
}

void                  
CXCATContextManager::SignalDocumentDeath(CXCArticleDoc* pDeceasedDoc,
										 EXCATWindowType xwtDeceased)
{
	map_mdtDocumentTemplates[xwtDeceased]->RemoveDocument((CDocument*)pDeceasedDoc);
}


BOOL
CXCATContextManager::IsEditExisting()
{
    return m_bEditExisting;
}


void
CXCATContextManager::SetEditExisting(BOOL bEdit)
{
    m_bEditExisting = bEdit;
}


BOOL
CXCATContextManager::IsIsLike()
{
    return m_bIsLike;
}


void
CXCATContextManager::SetIsLike(BOOL bIsLike)
{
    m_bIsLike = bIsLike;
}


BOOL
CXCATContextManager::IsArticleOnly()
{
    return m_bArticleOnly;
}


void
CXCATContextManager::SetArticleOnly(BOOL bAOnly)
{
    m_bArticleOnly = bAOnly;
}


CXArticle   
*CXCATContextManager::GetArticle()
{
    return p_cxaTheArticle;
}


void
CXCATContextManager::SetArticle(CXArticle *pArticle)
{
    p_cxaTheArticle = pArticle;
}


CXPageSpec  
*CXCATContextManager::GetPageSpec()
{
    return p_cxpThePageSpec;
}


void
CXCATContextManager::SetPageSpec(CXPageSpec *pPageSpec)
{
    p_cxpThePageSpec = pPageSpec;
}


