#include "stdafx.h"
#include "string.h"

void NestedIfExample()
{
	// open an input file, and output file, and a log file
	FILE * fpIn;
	FILE * fpOut;
	FILE * fpLog;

	fpIn = fopen( "c:\\temp\\in.txt", "r" );
	if ( fpIn )
	{
		fpOut = fopen( "c:\\temp\\out.txt", "w+" );
		if ( fpOut )
		{
			fpLog = fopen( "c:\\temp\\log.out", "a+" );
			if ( fpOut )
			{
				// do some processing on fpIn producing fpOut while
				// logging to fpLog


				// close all the files
				fclose( fpIn );
				fclose( fpOut );
				fclose( fpLog );
			}
			else
			{
				// error opening log file - close both in and out
				fclose( fpIn );
				fclose( fpOut );
				printf( "error opening log file\n");
			}
		}
		else
		{
			// error opening out file - close the in file
			fclose( fpIn );
			printf( "error opening output file\n");
		}
	}
	else
	{
		printf("error opening input file\n");
	}

}

void GotoExample()
{
	// open an input file, and output file, and a log file
	FILE * fpIn = NULL;
	FILE * fpOut = NULL;
	FILE * fpLog = NULL;

	fpIn = fopen( "c:\\temp\\in.txt", "r" );
	if ( ! fpIn )
	{
		printf("error opening input file\n");
		goto done;
	}


	fpOut = fopen( "c:\\temp\\out.txt", "w+" );
	if ( ! fpOut )
	{
		printf( "error opening output file\n");
		goto done;
	}

	fpLog = fopen( "c:\\temp\\log.out", "a+" );
	if ( ! fpOut )
	{
		printf( "error opening log file\n");
		goto done;
	}

	// do some processing on fpIn producing fpOut while
	// logging to fpLog

done:
	// close all the files
	if ( fpIn )
		fclose( fpIn );

	if ( fpOut )
		fclose( fpOut );

	if (fpOut )
		fclose( fpLog );
}

void ExceptionExample()
{
	// open an input file, and output file, and a log file
	FILE * fpIn = NULL;
	FILE * fpOut = NULL;
	FILE * fpLog = NULL;

	try
	{
		fpIn = fopen( "c:\\temp\\in.txt", "r" );
		if ( ! fpIn )
			throw 1;

		fpOut = fopen( "c:\\temp\\out.txt", "w+" );
		if ( ! fpOut )
			throw 2;

		fpLog = fopen( "c:\\temp\\log.out", "a+" );
		if ( ! fpOut )
			throw 3;

		// do some processing on fpIn producing fpOut while
		// logging to fpLog

	}
	catch( int i )
	{
		switch ( i )
		{
		case 1:
			printf("error opening input file\n");
			break;
		case 2:
			printf( "error opening output file\n");
			break;
		case 3:
			printf( "error opening log file\n");
			break;
		}
	}

	// clean up
	if ( fpIn )
		fclose( fpIn );

	if ( fpOut )
		fclose( fpOut );

	if (fpOut )
		fclose( fpLog );
}

class CException
{
private:
	int	m_iError;
	char m_szError[255];

public:
	CException() { m_iError = 0; m_szError[0] = '\0'; }
	int GetErrno( void ) { return m_iError; }
	void SetErrno( int error ) { m_iError = error; }
	int GetErrorMessage( char * lpszError, unsigned uMaxError )
	{
		if ( lpszError && (uMaxError > strlen( m_szError )) )
		{
			strncpy( lpszError, m_szError, uMaxError );
			return 1;
		}
		return 0;
	}
	void SetErrorMessage( char * lpszError )
	{
		strncpy(m_szError, lpszError, 255);
		m_szError[ 255 ] = '\0';
	}
};

int SomeFunc( void )
{
	CException e;
	e.SetErrno( 99 );
	e.SetErrorMessage( "Throwing CExceptions" );
	
	throw e;

	return 0; // never reached
}

int main1(int argc, char* argv[])
{
	ExceptionExample();

	return 0;
}

int main2(int argc, char* argv[])
{
		SomeFunc();

	return 0;
}

int main(int argc, char* argv[])
{
	try
	{
		SomeFunc();
	}
	catch( CException e )
	{
		char szerr[ 255 ] = "/0";

		e.GetErrorMessage( szerr, 255 );
		printf("Saw CException %d - %s\n", e.GetErrno(), szerr );
	}

	return 0;
}

