#include "stdafx.h"
#include "TestExceptions.h"

int CTestSEHExceptions::TestSEH()
{
	_try
	{
		_try
		{
			int i, zero;

			zero = 0;
			i = 1/zero;
			i = 1;
		}
//		_except( EXCEPTION_CONTINUE_SEARCH )
//		_except( EXCEPTION_CONTINUE_EXECUTION )
		_except( EXCEPTION_EXECUTE_HANDLER )
		{
			::MessageBox(NULL,"Saw inner SEH exception...","",MB_OK );
		}
	}
	_except( EXCEPTION_CONTINUE_SEARCH )
//	_except(GetExceptionCode() == EXCEPTION_INT_DIVIDE_BY_ZERO)
	{
		::MessageBox(NULL,"Saw outer SEH exception...","",MB_OK );
	}

	return 0;
}

int CTestSEHExceptions::TestNestedSEH( void )
{
	_try
	{
		SEHCaller();
	}
	_except(GetExceptionCode() == EXCEPTION_INT_DIVIDE_BY_ZERO)
	{
		::MessageBox(NULL,"Saw nested SEH exception...","",MB_OK );
	}

	// execution continues here after the exception handler runs
	return 0;
}

int CTestSEHExceptions::TestSEHTermHandler( void )
{
	int retval = 0;

	_try
	{
		retval = SEHTermA();
	}
	_except(GetExceptionCode() == EXCEPTION_INT_DIVIDE_BY_ZERO)
	{
		::MessageBox(NULL,"Saw SEH exception...","",MB_OK );
	}

	return 0;
}


int CTestSEHExceptions::SEHCaller( void )
{
	return SEHGenerator();
}

int CTestSEHExceptions::SEHGenerator( void )
{
	int i, zero;

	zero = 0;
	i = 1/zero;

	return i;
}

int CTestSEHExceptions::SEHTermA( void )
{
	_try
	{
		return SEHTermB() + 1;
	}
	_finally
	{
		::MessageBox(NULL,"At Termination Handler A...","",MB_OK );
	}
	return 0;
}

int CTestSEHExceptions::SEHTermB( void )
{
	_try
	{
		return SEHTermC() + 1;
	}
	_finally
	{
		::MessageBox(NULL,"At Termination Handler B...","",MB_OK );
	}
	return 0;
}

int CTestSEHExceptions::SEHTermC( void )
{
	_try
	{
		return SEHGenerator() + 1;
	}
	_finally
	{
		::MessageBox(NULL,"At Termination Handler C...","",MB_OK );
	}
	return 0;
}

int CTestMFCExceptions::TestMFC()
{
	unsigned short szErrString[ 255 ];

	try
	{
		CFileException::ThrowErrno( 1 );
	}
	catch( CException * e)
	{
		e->GetErrorMessage( (LPTSTR)&szErrString, 255 );
		e->ReportError();
		e->Delete();
		::MessageBox(NULL,"Saw MFC exception...","",MB_OK );
	}

	return 0;
}

int CTestMFCExceptions::TestNestedMFC()
{
	unsigned short szErrString[ 255 ];
	int i = -1;

	try
	{
		i = MFCFuncA();
		i = -1;
	}
	catch( CException * e)
	{
		e->GetErrorMessage( (LPTSTR)&szErrString, 255 );
		e->ReportError();
		e->Delete();
		::MessageBox(NULL,"Saw MFC Nested exception...","",MB_OK );
	}

	return 0;
}

int CTestMFCExceptions::MFCFuncA( void )
{
	return MFCFuncB();
}

int CTestMFCExceptions::MFCFuncB( void )
{
	return MFCFuncC();
}

int CTestMFCExceptions::MFCFuncC( void )
{
	CFileException::ThrowErrno( 2 );

	return 99;	// won't happen
}

int CTestMFCExceptions::TestAppException( void )
{
	unsigned short szErrString[ 255 ];
	int i = -1;

	try
	{
		CAppException * pe = new CAppException( 99 );
		throw( pe );
	}
	catch( CAppException * e )
	{
		e->GetErrorMessage( (LPTSTR)&szErrString, 255 );
		e->ReportError();
		e->Delete();
		::MessageBox(NULL,"Saw custom App exception...","",MB_OK );
	}

	return 0;
}


IMPLEMENT_DYNAMIC( CAppException, CException )

BOOL CAppException::GetErrorMessage( 
		LPTSTR lpszError, 
		UINT nMaxError, 
		PUINT pnHelpContext )
{
	TCHAR szErr[ 255 ];

	_stprintf( szErr, "Fatal Error - %ld", m_ulTheCause );
	
	// check if the buffer is too small
	if ( nMaxError <= _tcslen( szErr ) )
		return FALSE;

	_tcsncpy( lpszError, szErr, nMaxError );
	if (pnHelpContext ) *pnHelpContext = 0;

	return TRUE;
}

