//-----------------------------------------------------------------
// Main Frame Window Object
// C++ Header - MainFrame.h
//-----------------------------------------------------------------

#ifndef __MAINFRAME_H__
#define __MAINFRAME_H__

//-----------------------------------------------------------------
// Inclusions
//-----------------------------------------------------------------
#include <MMSystem.h>
#include <DSound.h>

//-----------------------------------------------------------------
// Defines
//-----------------------------------------------------------------
#define NUMSOUNDS 13

//-----------------------------------------------------------------
// CMainFrame Class - Main Frame Window Object
//-----------------------------------------------------------------
class CMainFrame : public CFrameWnd {
  // Private Data
private:
  LPDIRECTSOUND       m_pDirectSound;
  LPDIRECTSOUNDBUFFER m_pDSBuffer[NUMSOUNDS];
  UINT                m_uiTimerID;
  LONG                m_lHeliPan;
  LONG                m_lHeliPanInc;

  // Public Constructor(s)/Destructor
public:
                      CMainFrame();
  virtual             ~CMainFrame();

  // Public Methods
public:
  BOOL                Create(const CString& sTitle);

  // Protected Methods
public:
  BOOL                InitDirectSound();
  void                CleanupDirectSound();
  BOOL                InitDSBuffers();
  BOOL                RestoreDSBuffers();

  // Message Handler Methods
protected:
  afx_msg int         OnCreate(LPCREATESTRUCT lpCreateStruct);
  afx_msg void        OnDestroy();
  afx_msg void        OnPaint();
  afx_msg void        OnTimer(UINT nIDEvent);

  // Message Map & Runtime Support
protected:
  DECLARE_MESSAGE_MAP()
  DECLARE_DYNCREATE(CMainFrame)
};

#endif
